import { __decorate } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Component, NgModule, forwardRef, Input, Directive, HostListener } from '@angular/core';
import { Validators, FormControl, NgModel, NG_VALIDATORS } from '@angular/forms';
import { isNullOrUndefined } from '@angular-boot/util';

let ValidationService = class ValidationService {
    constructor() { }
};
ValidationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ValidationService_Factory() { return new ValidationService(); }, token: ValidationService, providedIn: "root" });
ValidationService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], ValidationService);

let ValidationComponent = class ValidationComponent {
    constructor() { }
    ngOnInit() {
    }
};
ValidationComponent = __decorate([
    Component({
        selector: 'lib-validation',
        template: `
    <p>
      validation works!
    </p>
  `
    })
], ValidationComponent);

let ValidationModule = class ValidationModule {
};
ValidationModule = __decorate([
    NgModule({
        declarations: [ValidationComponent],
        imports: [],
        exports: [ValidationComponent]
    })
], ValidationModule);

function isPresent(obj) {
    return obj !== undefined && obj !== null;
}
function isDate(obj) {
    return !/Invalid|NaN/.test(new Date(obj).toString());
}
function parseDate(obj) {
    try {
        if (typeof obj === 'object' && obj.year != null && obj.month != null && obj.day != null) {
            return obj.year + '-' + obj.month + '-' + obj.day;
        }
    }
    catch (e) { }
    return obj;
}
// -----------------------------
function deleteElementByClassName(className) {
    const elements = document.getElementsByClassName(className);
    while (elements.length > 0) {
        elements[0].parentNode.removeChild(elements[0]);
    }
}
// -----------------------------
// -----------------------------
function addValidationEl(dest, vClassSuffix, innerHtml, _ValidationConfig) {
    deleteElementByClassName(dest + vClassSuffix);
    document.getElementById(dest).appendChild(getMyValidationElement(dest, vClassSuffix, innerHtml, _ValidationConfig));
}
function delValidationEl(dest, vClassSuffix) {
    deleteElementByClassName(dest + vClassSuffix);
}
function getMyValidationElement(dest, vClassSuffix, innerHtml, _ValidationConfig) {
    const myEl = _ValidationConfig.getValidationAlertElement(dest + vClassSuffix);
    myEl.innerHTML = innerHtml;
    return myEl;
}
// -----------------------------
// export function getValidationAlertElement(vClass): HTMLElement {
//   const myAlert: HTMLElement = document.createElement('div');
//   myAlert.classList.add('alert');
//   myAlert.classList.add('alert-danger');
//   myAlert.classList.add(vClass);
//   return myAlert;
// }
// -----------------------------
// export function addValidationElComplex(dest, vClassSuffix, value, valueTitle) {
//   deleteElementByClassName(dest + vClassSuffix);
//   document.getElementById(dest).appendChild(getMyValidationElementComplex(dest, vClassSuffix, value, valueTitle));
// }
// export function getMyValidationElementComplex(dest, vClassSuffix, value, valueTitle) {
//   const myEl = getValidationAlertElement(dest + vClassSuffix);
//   if (!isNullOrUndefined(valueTitle)) {
//     myEl.innerHTML = new ValidationMessage().getEqual(valueTitle);
//   } else {
//     myEl.innerHTML = new ValidationMessage().getEqual(value);
//   }
//   return myEl;
// }
// -----------------------------
// -----------------------------
function manageDelValidationAlert(dest, vClassSuffix) {
    if (!isNullOrUndefined(dest)) {
        delValidationEl(dest, vClassSuffix);
    }
}
function manageAddValidationAlert(dest, vClassSuffix, innerHTML, _ValidationConfig) {
    if (!isNullOrUndefined(dest)) {
        addValidationEl(dest, vClassSuffix, innerHTML, _ValidationConfig);
    }
}
// -----------------------------

const arrayLength = (value) => {
    return (control) => {
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const obj = control.value;
        return Array.isArray(obj) && obj.length >= +value ? null : { arrayLength: +value };
    };
};

const base64 = (control) => {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    const v = control.value;
    return /^(?:[A-Z0-9+\/]{4})*(?:[A-Z0-9+\/]{2}==|[A-Z0-9+\/]{3}=|[A-Z0-9+\/]{4})$/i.test(v) ? null : { 'nbvBase64': true };
};

const creditCard = (control) => {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    const v = control.value;
    const sanitized = v.replace(/[^0-9]+/g, '');
    // problem with chrome
    /* tslint:disable */
    if (!(/^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11}|(?:9792)\d{12})$/.test(sanitized))) {
        return { nbvCreditCard: true };
    }
    /* tslint:enable */
    let sum = 0;
    let digit;
    let tmpNum;
    let shouldDouble;
    for (let i = sanitized.length - 1; i >= 0; i--) {
        digit = sanitized.substring(i, (i + 1));
        tmpNum = parseInt(digit, 10);
        if (shouldDouble) {
            tmpNum *= 2;
            if (tmpNum >= 10) {
                sum += ((tmpNum % 10) + 1);
            }
            else {
                sum += tmpNum;
            }
        }
        else {
            sum += tmpNum;
        }
        shouldDouble = !shouldDouble;
    }
    if (Boolean((sum % 10) === 0 ? sanitized : false)) {
        return null;
    }
    return { nbvCreditCard: true };
};

const date = (control) => {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    const v = control.value;
    return isDate(v) ? null : { nbvDate: true };
};

const dateISO_8601 = (control) => {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    const v = control.value;
    return /^\d{4}[\/\-](0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])$|^[۰-۹]{4}[\/\-](۰?[۱-۹]|۱[۰۱۲])[\/\-](۰?[۱-۹]|[۱۲][۰-۹]|۳[۰۱])$/.test(v) ? null : { nbvDateISO_8601: true };
};

const digits = (control) => {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    const v = control.value;
    // return /^\d+$/.test(v) ? null : {digits: true};
    return /^([0-9]*)$|^([۰-۹]*)$/.test(v) ? null : { nbvDigits: true };
};

const nationalCode = (control) => {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    const v = control.value;
    if (isValidNationalCode(v)) {
        return null;
    }
    else {
        return { nationalCode: true };
    }
};
function isValidNationalCode(value) {
    let isValid = false;
    if (!/^\d{10}$/.test(value)) {
        isValid = false;
    }
    else {
        const check = +value[9];
        let sum = 0;
        let i;
        for (i = 0; i < 9; ++i) {
            sum += (+value[i]) * (10 - i);
        }
        sum %= 11;
        if ((sum < 2 && check === sum) || (sum >= 2 && check + sum === 11)) {
            isValid = true;
        }
    }
    return isValid;
}

const email = (control) => {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    const v = control.value;
    /* tslint:disable */
    return /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(v) ? null : { 'nbvEmail': true };
    /* tslint:enable */
};

const equal = (val) => {
    return (control) => {
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = control.value;
        return val === v ? null : { nbvEqual: true };
    };
};

const equalTo = (equalControl) => {
    let subscribe = false;
    return (control) => {
        if (!subscribe) {
            subscribe = true;
            equalControl.valueChanges.subscribe(() => {
                control.updateValueAndValidity();
            });
        }
        const v = control.value;
        return equalControl.value === v ? null : { nbvEqualTo: true };
    };
};

const gt = (value) => {
    return (control) => {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = +control.value;
        return v > +value ? null : { nbvGt: true };
    };
};

const gte = (value) => {
    return (control) => {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = +control.value;
        return v >= +value ? null : { nbvGte: true };
    };
};

const json = (control) => {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    const v = control.value;
    try {
        const obj = JSON.parse(v);
        if (Boolean(obj) && typeof obj === 'object') {
            return null;
        }
    }
    catch (e) { }
    return { nbvJson: true };
};

const lt = (value) => {
    return (control) => {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = +control.value;
        return v < +value ? null : { nbvLt: true };
    };
};

const lte = (value) => {
    return (control) => {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = +control.value;
        return v <= +value ? null : { nbvLte: true };
    };
};

const max = (value) => {
    return (control) => {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = +control.value;
        return v <= +value ? null : { actualValue: v, requiredValue: +value, nbvMax: true };
    };
};

const maxDate = (maxInput) => {
    let value;
    let subscribe = false;
    let maxValue = maxInput;
    const isForm = maxInput instanceof FormControl || maxInput instanceof NgModel;
    return (control) => {
        if (!subscribe && isForm) {
            subscribe = true;
            maxInput.valueChanges.subscribe(() => {
                control.updateValueAndValidity();
            });
        }
        if (isForm) {
            maxValue = maxInput.value;
        }
        value = parseDate(maxValue);
        if (!isDate(value) && !(value instanceof Function)) {
            if (value == null) {
                return null;
            }
            else if (isForm) {
                return { nbvMaxDate: true, error: 'maxDate is invalid' };
            }
            else {
                throw Error('maxDate value must be or return a formatted date');
            }
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const d = new Date(parseDate(control.value)).getTime();
        if (!isDate(d)) {
            return { value: true };
        }
        if (value instanceof Function) {
            value = value();
        }
        return d <= new Date(value).getTime() ? null : { nbvMaxDate: true, error: 'greater than maxDate' };
    };
};

const min = (value) => {
    return (control) => {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = +control.value;
        return v >= +value ? null : { actualValue: v, requiredValue: +value, nbvMin: true };
    };
};

const minDate = (minInput) => {
    let value;
    let subscribe = false;
    let minValue = minInput;
    const isForm = minInput instanceof FormControl || minInput instanceof NgModel;
    return (control) => {
        if (!subscribe && isForm) {
            subscribe = true;
            minInput.valueChanges.subscribe(() => {
                control.updateValueAndValidity();
            });
        }
        if (isForm) {
            minValue = minInput.value;
        }
        value = parseDate(minValue);
        if (!isDate(value) && !(value instanceof Function)) {
            if (value == null) {
                return null;
            }
            else if (isForm) {
                return { nbvMinDate: true, error: 'minDate is invalid' };
            }
            else {
                throw Error('minDate value must be or return a formatted date');
            }
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const d = new Date(parseDate(control.value)).getTime();
        if (!isDate(d)) {
            return { value: true };
        }
        if (value instanceof Function) {
            value = value();
        }
        return d >= new Date(value).getTime() ? null : { nbvMinDate: true, error: 'lower than minDate' };
    };
};

const notEqual = (val) => {
    return (control) => {
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = control.value;
        return val !== v ? null : { nbvNotEqual: true };
    };
};

/**
 * @author Jafar Amini in March 2018.
 */
var ValidationSrcType;
(function (ValidationSrcType) {
    ValidationSrcType[ValidationSrcType["FormControl"] = 'FormControl'] = "FormControl";
    ValidationSrcType[ValidationSrcType["CustomValue"] = 'CustomValue'] = "CustomValue";
})(ValidationSrcType || (ValidationSrcType = {}));

/**
 * Edited by Jafar Amini in March 2018.
 */
const notEqualTo = (notEqualControl, validationOptions) => {
    let subscribe = false;
    return (control) => {
        const v = control.value;
        // alert(typeof notEqualControl);
        if (!isNullOrUndefined(validationOptions) &&
            validationOptions.validationSrcType === ValidationSrcType.FormControl) {
            if (!subscribe) {
                subscribe = true;
                notEqualControl.valueChanges.subscribe(() => {
                    control.updateValueAndValidity();
                });
            }
            return notEqualControl.value !== v ? null : { nbvNotEqualTo: true };
        }
        else if (!isNullOrUndefined(validationOptions) &&
            validationOptions.validationSrcType === ValidationSrcType.CustomValue) {
            if (isPresent(Validators.required(control))) {
                return null;
            }
            return notEqualControl !== v ? null : { nbvNotEqualTo: true };
        }
        else {
            if (isPresent(Validators.required(control))) {
                return null;
            }
            return notEqualControl !== v ? null : { nbvNotEqualTo: true };
        }
    };
};

const number = (control) => {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    const v = control.value;
    return /^(?:-?\d+|-?\d{1,3}(?:,\d{3})+)?(?:\.\d+)?$/.test(v) ? null : { 'nbvNumber': true };
};

const property = (value) => {
    return (control) => {
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const properties = value.split(',');
        let errorProperty = new Array();
        const obj = control.value;
        let isValid = true;
        for (const prop of properties) {
            if (isNullOrUndefined(obj[prop])) {
                isValid = false;
                // break;
                errorProperty.push(prop);
            }
        }
        return isValid ? null : { hasProperty: true, nbvProperty: value, errorProperty: errorProperty };
    };
};

const range = (value) => {
    return (control) => {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = +control.value;
        return v >= value[0] && v <= value[1] ? null : { actualValue: v, requiredValue: value, nbvRange: true };
    };
};

const rangeLength = (value) => {
    return (control) => {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = control.value;
        return v.length >= value[0] && v.length <= value[1] ? null : { nbvRangeLength: true };
    };
};

const uuids = {
    '3': /^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    '4': /^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    '5': /^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    'all': /^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i
};
const uuid = (version) => {
    return (control) => {
        if (isPresent(Validators.required(control))) {
            return null;
        }
        const v = control.value;
        const pattern = uuids[version] || uuids.all;
        return (new RegExp(pattern)).test(v) ? null : { nbvUuid: true };
    };
};

const url = (control) => {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    const v = control.value;
    /* tslint:disable */
    return /^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})).?)(?::\d{2,5})?(?:[/?#]\S*)?$/i.test(v) ? null : { 'nbvUrl': true };
    /* tslint:enable */
};

const ARRAY_LENGTH_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => ArrayLengthValidator),
    multi: true
};
let ArrayLengthValidator = class ArrayLengthValidator {
    ngOnInit() {
        this.validator = arrayLength(this.arrayLength);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'arrayLength') {
                this.validator = arrayLength(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        return this.validator(c);
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
__decorate([
    Input()
], ArrayLengthValidator.prototype, "arrayLength", void 0);
ArrayLengthValidator = __decorate([
    Directive({
        selector: '[arrayLength][formControlName],[arrayLength][formControl],[arrayLength][ngModel]',
        providers: [ARRAY_LENGTH_VALIDATOR]
    })
], ArrayLengthValidator);

class ValidationMessage {
}

/**
 * @author Jafar Amini in March 2018.
 */
class ValidationConfig {
}

const BASE64_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => Base64Validator),
    multi: true
};
let Base64Validator = class Base64Validator {
    constructor(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        // return base64(c);
        const vClassSuffix = '-nbvBase64';
        const iValidated = base64(c);
        if (iValidated) {
            const innerHTML = getInnerHTML(this.nbvBase64MsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
Base64Validator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], Base64Validator.prototype, "dest", void 0);
__decorate([
    Input()
], Base64Validator.prototype, "nbvBase64MsgHtml", void 0);
Base64Validator = __decorate([
    Directive({
        selector: '[nbvBase64][formControlName],[nbvBase64][formControl],[nbvBase64][ngModel]',
        providers: [BASE64_VALIDATOR]
    })
], Base64Validator);
function getInnerHTML(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getBase64();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const CREDIT_CARD_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => CreditCardValidator),
    multi: true
};
let CreditCardValidator = class CreditCardValidator {
    constructor(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        // return creditCard(c);
        const vClassSuffix = '-nbvCreditCard';
        const iValidated = creditCard(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$1(this.nbvCreditCardMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
CreditCardValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], CreditCardValidator.prototype, "dest", void 0);
__decorate([
    Input()
], CreditCardValidator.prototype, "nbvCreditCardMsgHtml", void 0);
CreditCardValidator = __decorate([
    Directive({
        selector: '[nbvCreditCard][formControlName],[nbvCreditCard][formControl],[nbvCreditCard][ngModel]',
        providers: [CREDIT_CARD_VALIDATOR]
    })
], CreditCardValidator);
function getInnerHTML$1(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getCreditCard();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const DATE_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => DateValidator),
    multi: true
};
let DateValidator = class DateValidator {
    constructor(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        // return date(c);
        const vClassSuffix = '-nbvDate';
        const iValidated = date(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$2(this.nbvDateMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
DateValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], DateValidator.prototype, "dest", void 0);
__decorate([
    Input()
], DateValidator.prototype, "nbvDateMsgHtml", void 0);
DateValidator = __decorate([
    Directive({
        selector: '[nbvDate][formControlName],[nbvDate][formControl],[nbvDate][ngModel]',
        providers: [DATE_VALIDATOR]
    })
], DateValidator);
function getInnerHTML$2(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getDate();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const DATE_ISO_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => DateISOValidator),
    multi: true
};
let DateISOValidator = class DateISOValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        const vClassSuffix = '-nbvDateISO_8601';
        const iValidated = dateISO_8601(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$3(this.nbvDateISO_8601MsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
DateISOValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], DateISOValidator.prototype, "dest", void 0);
__decorate([
    Input()
], DateISOValidator.prototype, "nbvDateISO_8601MsgHtml", void 0);
DateISOValidator = __decorate([
    Directive({
        selector: '[nbvDateISO_8601][formControlName],[nbvDateISO_8601][formControl],[nbvDateISO_8601][ngModel]',
        providers: [DATE_ISO_VALIDATOR]
    })
], DateISOValidator);
function getInnerHTML$3(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getDateISO_8601();
        innerHTML = vMessage.title + '<br/>' + vMessage.description;
    }
    return innerHTML;
}

const DIGITS_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => DigitsValidator),
    multi: true
};
let DigitsValidator = class DigitsValidator {
    constructor(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        const vClassSuffix = '-nbvDigits';
        const iValidated = digits(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$4(this.nbvDigitsMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
DigitsValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], DigitsValidator.prototype, "dest", void 0);
__decorate([
    Input()
], DigitsValidator.prototype, "nbvDigitsMsgHtml", void 0);
DigitsValidator = __decorate([
    Directive({
        selector: '[nbvDigits][formControlName],[nbvDigits][formControl],[nbvDigits][ngModel]',
        providers: [DIGITS_VALIDATOR]
    })
], DigitsValidator);
function getInnerHTML$4(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getDigits();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}
// export  function Fa2En(value: any): any {
//   const englishNumbers = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'];
//   const persianNumbers = ['۱', '۲', '۳', '۴', '۵', '۶', '۷', '۸', '۹', '۰'];
//   if(isNullOrUndefined(value))
//     return value;
//   let myvalue: string = value.toString();
//   if(!isNullOrUndefined(value)) {
//     for (let i = 0, numbersLen = persianNumbers.length; i < numbersLen; i++) {
//       myvalue = myvalue.replace(new RegExp(persianNumbers[i], 'g'), englishNumbers[i]);
//     }
//   }
//   return myvalue;
// }

const EMAIL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => EmailValidator),
    multi: true
};
let EmailValidator = class EmailValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        const vClassSuffix = '-nbvEmail';
        const iValidated = email(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$5(this.nbvEmailMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
EmailValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], EmailValidator.prototype, "dest", void 0);
__decorate([
    Input()
], EmailValidator.prototype, "nbvEmailMsgHtml", void 0);
EmailValidator = __decorate([
    Directive({
        selector: '[nbvEmail][formControlName],[nbvEmail][formControl],[nbvEmail][ngModel]',
        providers: [EMAIL_VALIDATOR]
    })
], EmailValidator);
function getInnerHTML$5(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getEmail();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const EQUAL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => EqualValidator),
    multi: true
};
let EqualValidator = class EqualValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = equal(this.nbvEqual);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvEqual') {
                this.validator = equal(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvEqual';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$6(this.nbvEqual, this.nbvEqualٰValueTitle, this.nbvEqualMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
EqualValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], EqualValidator.prototype, "nbvEqual", void 0);
__decorate([
    Input()
], EqualValidator.prototype, "dest", void 0);
__decorate([
    Input()
], EqualValidator.prototype, "nbvEqual\u0670ValueTitle", void 0);
__decorate([
    Input()
], EqualValidator.prototype, "nbvEqualMsgHtml", void 0);
EqualValidator = __decorate([
    Directive({
        selector: '[nbvEqual][formControlName],[nbvEqual][formControl],[nbvEqual][ngModel]',
        providers: [EQUAL_VALIDATOR]
    })
], EqualValidator);
function getInnerHTML$6(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getEqual(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getEqual(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const EQUAL_TO_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => EqualToValidator),
    multi: true
};
let EqualToValidator = class EqualToValidator {
    constructor(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = equalTo(this.nbvEqualTo);
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvEqualTo';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$7(this.nbvEqualTo, this.nbvEqualToValTitle, this.nbvEqualToMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
EqualToValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], EqualToValidator.prototype, "nbvEqualTo", void 0);
__decorate([
    Input()
], EqualToValidator.prototype, "dest", void 0);
__decorate([
    Input()
], EqualToValidator.prototype, "nbvEqualToValTitle", void 0);
__decorate([
    Input()
], EqualToValidator.prototype, "nbvEqualToMsgHtml", void 0);
EqualToValidator = __decorate([
    Directive({
        selector: '[nbvEqualTo][formControlName],[nbvEqualTo][formControl],[nbvEqualTo][ngModel]',
        providers: [EQUAL_TO_VALIDATOR]
    })
], EqualToValidator);
function getInnerHTML$7(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getEqualTo(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getEqualTo(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const GREATER_THAN_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => GreaterThanValidator),
    multi: true
};
let GreaterThanValidator = class GreaterThanValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = gt(this.nbvGt);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvGt') {
                this.validator = gt(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
            // if (key === 'des') {
            //   alert(this.des);
            // }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvGt';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$8(this.nbvGt, this.nbvGtٰValTitle, this.nbvGtMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
GreaterThanValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], GreaterThanValidator.prototype, "nbvGt", void 0);
__decorate([
    Input()
], GreaterThanValidator.prototype, "dest", void 0);
__decorate([
    Input()
], GreaterThanValidator.prototype, "nbvGt\u0670ValTitle", void 0);
__decorate([
    Input()
], GreaterThanValidator.prototype, "nbvGtMsgHtml", void 0);
GreaterThanValidator = __decorate([
    Directive({
        selector: '[nbvGt][formControlName],[nbvGt][formControl],[nbvGt][ngModel]',
        providers: [GREATER_THAN_VALIDATOR]
    })
], GreaterThanValidator);
function getInnerHTML$8(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getGt(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getGt(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const GREATER_THAN_EQUAL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => GreaterThanEqualValidator),
    multi: true
};
let GreaterThanEqualValidator = class GreaterThanEqualValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = gte(this.nbvGte);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvGte') {
                this.validator = gte(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvGte';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$9(this.nbvGte, this.nbvGteٰValTitle, this.nbvGteMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
GreaterThanEqualValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], GreaterThanEqualValidator.prototype, "nbvGte", void 0);
__decorate([
    Input()
], GreaterThanEqualValidator.prototype, "dest", void 0);
__decorate([
    Input()
], GreaterThanEqualValidator.prototype, "nbvGte\u0670ValTitle", void 0);
__decorate([
    Input()
], GreaterThanEqualValidator.prototype, "nbvGteMsgHtml", void 0);
GreaterThanEqualValidator = __decorate([
    Directive({
        selector: '[nbvGte][formControlName],[nbvGte][formControl],[nbvGte][ngModel]',
        providers: [GREATER_THAN_EQUAL_VALIDATOR]
    })
], GreaterThanEqualValidator);
function getInnerHTML$9(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getGte(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getGte(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const JSON_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => JSONValidator),
    multi: true
};
let JSONValidator = class JSONValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        // return json(c);
        const vClassSuffix = '-nbvJson';
        const iValidated = json(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$a(this.nbvJsonMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
JSONValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], JSONValidator.prototype, "dest", void 0);
__decorate([
    Input()
], JSONValidator.prototype, "nbvJsonMsgHtml", void 0);
JSONValidator = __decorate([
    Directive({
        selector: '[nbvJson][formControlName],[nbvJson][formControl],[nbvJson][ngModel]',
        providers: [JSON_VALIDATOR]
    })
], JSONValidator);
function getInnerHTML$a(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getJson();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const LESS_THAN_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => LessThanValidator),
    multi: true
};
let LessThanValidator = class LessThanValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = lt(this.nbvLt);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvLt') {
                this.validator = lt(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvLt';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$b(this.nbvLt, this.nbvLtValTitle, this.nbvLtMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
LessThanValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], LessThanValidator.prototype, "nbvLt", void 0);
__decorate([
    Input()
], LessThanValidator.prototype, "dest", void 0);
__decorate([
    Input()
], LessThanValidator.prototype, "nbvLtValTitle", void 0);
__decorate([
    Input()
], LessThanValidator.prototype, "nbvLtMsgHtml", void 0);
LessThanValidator = __decorate([
    Directive({
        selector: '[nbvLt][formControlName],[nbvLt][formControl],[nbvLt][ngModel]',
        providers: [LESS_THAN_VALIDATOR]
    })
], LessThanValidator);
function getInnerHTML$b(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getLt(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getLt(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const LESS_THAN_EQUAL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => LessThanEqualValidator),
    multi: true
};
let LessThanEqualValidator = class LessThanEqualValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = lte(this.nbvLte);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvLte') {
                this.validator = lte(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvLte';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$c(this.nbvLte, this.nbvLteٰValTitle, this.nbvLteMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
LessThanEqualValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], LessThanEqualValidator.prototype, "nbvLte", void 0);
__decorate([
    Input()
], LessThanEqualValidator.prototype, "dest", void 0);
__decorate([
    Input()
], LessThanEqualValidator.prototype, "nbvLte\u0670ValTitle", void 0);
__decorate([
    Input()
], LessThanEqualValidator.prototype, "nbvLteMsgHtml", void 0);
LessThanEqualValidator = __decorate([
    Directive({
        selector: '[nbvLte][formControlName],[nbvLte][formControl],[nbvLte][ngModel]',
        providers: [LESS_THAN_EQUAL_VALIDATOR]
    })
], LessThanEqualValidator);
function getInnerHTML$c(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getLte(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getLte(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const MAX_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => MaxValidator),
    multi: true
};
let MaxValidator = class MaxValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = max(this.nbvMax);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvMax') {
                this.validator = max(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvMax';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$d(this.nbvMax, this.nbvMaxValTitle, this.nbvMaxMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
MaxValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], MaxValidator.prototype, "nbvMax", void 0);
__decorate([
    Input()
], MaxValidator.prototype, "dest", void 0);
__decorate([
    Input()
], MaxValidator.prototype, "nbvMaxValTitle", void 0);
__decorate([
    Input()
], MaxValidator.prototype, "nbvMaxMsgHtml", void 0);
MaxValidator = __decorate([
    Directive({
        selector: '[nbvMax][formControlName],[nbvMax][formControl],[nbvMax][ngModel]',
        providers: [MAX_VALIDATOR]
    })
], MaxValidator);
function getInnerHTML$d(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getMax(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getMax(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const MAX_DATE_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => MaxDateValidator),
    multi: true
};
let MaxDateValidator = class MaxDateValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = maxDate(this.nbvMaxDate);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvMaxDate') {
                this.validator = maxDate(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvMaxDate';
        const iValidated = this.validator(c);
        if (iValidated) {
            console.log('this.maxDate --->', this.nbvMaxDate);
            const innerHTML = getInnerHTML$e(this.nbvMaxDate.value, this.nbvMaxDateValTitle, this.nbvMaxDateMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
MaxDateValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], MaxDateValidator.prototype, "nbvMaxDate", void 0);
__decorate([
    Input()
], MaxDateValidator.prototype, "dest", void 0);
__decorate([
    Input()
], MaxDateValidator.prototype, "nbvMaxDateValTitle", void 0);
__decorate([
    Input()
], MaxDateValidator.prototype, "nbvMaxDateMsgHtml", void 0);
MaxDateValidator = __decorate([
    Directive({
        selector: '[nbvMaxDate][formControlName],[nbvMaxDate][formControl],[nbvMaxDate][ngModel]',
        providers: [MAX_DATE_VALIDATOR]
    })
], MaxDateValidator);
function getInnerHTML$e(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getMaxDate(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getMaxDate(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const MIN_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => MinValidator),
    multi: true
};
let MinValidator = class MinValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = min(this.nbvMin);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvMin') {
                this.validator = min(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvMin';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$f(this.nbvMin, this.nbvMinValTitle, this.nbvMinMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
MinValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], MinValidator.prototype, "nbvMin", void 0);
__decorate([
    Input()
], MinValidator.prototype, "dest", void 0);
__decorate([
    Input()
], MinValidator.prototype, "nbvMinValTitle", void 0);
__decorate([
    Input()
], MinValidator.prototype, "nbvMinMsgHtml", void 0);
MinValidator = __decorate([
    Directive({
        selector: '[nbvMin][formControlName],[nbvMin][formControl],[nbvMin][ngModel]',
        providers: [MIN_VALIDATOR]
    })
], MinValidator);
function getInnerHTML$f(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getMin(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getMin(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const MIN_DATE_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => MinDateValidator),
    multi: true
};
let MinDateValidator = class MinDateValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = minDate(this.nbvMinDate);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvMinDate') {
                this.validator = minDate(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvMinDate';
        const iValidated = this.validator(c);
        if (iValidated) {
            // console.log('this.minDate --> ', this.nbvMinDate);
            const innerHTML = getInnerHTML$g(this.nbvMinDate.year, this.nbvMinDateValTitle, this.nbvMinDateMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
MinDateValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], MinDateValidator.prototype, "nbvMinDate", void 0);
__decorate([
    Input()
], MinDateValidator.prototype, "dest", void 0);
__decorate([
    Input()
], MinDateValidator.prototype, "nbvMinDateValTitle", void 0);
__decorate([
    Input()
], MinDateValidator.prototype, "nbvMinDateMsgHtml", void 0);
MinDateValidator = __decorate([
    Directive({
        selector: '[nbvMinDate][formControlName],[nbvMinDate][formControl],[nbvMinDate][ngModel]',
        providers: [MIN_DATE_VALIDATOR]
    })
], MinDateValidator);
function getInnerHTML$g(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getMinDate(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getMinDate(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const NOT_EQUAL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => NotEqualValidator),
    multi: true
};
let NotEqualValidator = class NotEqualValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = notEqual(this.nbvNotEqual);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvNotEqual') {
                this.validator = notEqual(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvNotEqual';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$h(this.nbvNotEqual, this.nbvNotEqualValueTitle, this.nbvNotEqualMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
NotEqualValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], NotEqualValidator.prototype, "nbvNotEqual", void 0);
__decorate([
    Input()
], NotEqualValidator.prototype, "dest", void 0);
__decorate([
    Input()
], NotEqualValidator.prototype, "nbvNotEqualValueTitle", void 0);
__decorate([
    Input()
], NotEqualValidator.prototype, "nbvNotEqualMsgHtml", void 0);
NotEqualValidator = __decorate([
    Directive({
        selector: '[nbvNotEqual][formControlName],[nbvNotEqual][formControl],[nbvNotEqual][ngModel]',
        providers: [NOT_EQUAL_VALIDATOR]
    })
], NotEqualValidator);
function getInnerHTML$h(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getNotEqual(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getNotEqual(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const NOT_EQUAL_TO_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => NotEqualToValidator),
    multi: true
};
let NotEqualToValidator = class NotEqualToValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = notEqualTo(this.nbvNotEqualTo, this.validationOptions);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvNotEqualTo') {
                this.validator = notEqualTo(changes[key].currentValue, this.validationOptions);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvNotEqualTo';
        const iValidated = this.validator(c);
        if (iValidated) {
            let tmpV;
            // alert('OOOOOOOOO------>' + typeof this.notEqualTo);
            if (!isNullOrUndefined(this.validationOptions) &&
                this.validationOptions.validationSrcType === ValidationSrcType.FormControl) {
                tmpV = this.nbvNotEqualTo.value;
            }
            else if (!isNullOrUndefined(this.validationOptions) &&
                this.validationOptions.validationSrcType === ValidationSrcType.CustomValue) {
                tmpV = this.nbvNotEqualTo;
            }
            else {
                tmpV = this.nbvNotEqualTo;
            }
            const innerHTML = getInnerHTML$i(tmpV, this.nbvNotEqualToValTitle, this.nbvNotEqualToMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
NotEqualToValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], NotEqualToValidator.prototype, "nbvNotEqualTo", void 0);
__decorate([
    Input()
], NotEqualToValidator.prototype, "dest", void 0);
__decorate([
    Input()
], NotEqualToValidator.prototype, "nbvNotEqualToValTitle", void 0);
__decorate([
    Input()
], NotEqualToValidator.prototype, "nbvNotEqualToMsgHtml", void 0);
__decorate([
    Input()
], NotEqualToValidator.prototype, "validationOptions", void 0);
NotEqualToValidator = __decorate([
    Directive({
        selector: '[nbvNotEqualTo][formControlName],[nbvNotEqualTo][formControl],[nbvNotEqualTo][ngModel]',
        providers: [NOT_EQUAL_TO_VALIDATOR]
    })
], NotEqualToValidator);
function getInnerHTML$i(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getNotEqualTo(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getNotEqualTo(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const NUMBER_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => NumberValidator),
    multi: true
};
let NumberValidator = class NumberValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        // return number(c);
        const vClassSuffix = '-nbvNumber';
        const iValidated = number(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$j(this.nbvNumberMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
NumberValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], NumberValidator.prototype, "dest", void 0);
__decorate([
    Input()
], NumberValidator.prototype, "nbvNumberMsgHtml", void 0);
NumberValidator = __decorate([
    Directive({
        selector: '[nbvNumber][formControlName],[nbvNumber][formControl],[nbvNumber][ngModel]',
        providers: [NUMBER_VALIDATOR]
    })
], NumberValidator);
function getInnerHTML$j(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getNumber();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const PROPERTY_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => PropertyValidator),
    multi: true
};
let PropertyValidator = class PropertyValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = property(this.nbvProperty);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvProperty') {
                this.validator = property(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvProperty';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$k(this.nbvPropertyMsgHtml, iValidated, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
PropertyValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], PropertyValidator.prototype, "nbvProperty", void 0);
__decorate([
    Input()
], PropertyValidator.prototype, "dest", void 0);
__decorate([
    Input()
], PropertyValidator.prototype, "nbvPropertyMsgHtml", void 0);
PropertyValidator = __decorate([
    Directive({
        selector: '[nbvProperty][formControlName],[nbvProperty][formControl],[nbvProperty][ngModel]',
        providers: [PROPERTY_VALIDATOR]
    })
], PropertyValidator);
function getInnerHTML$k(msgHtml, iValidated, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getProperty(iValidated);
        innerHTML = vMessage.title + '<br/>' + vMessage.description;
    }
    return innerHTML;
}

const RANGE_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => RangeValidator),
    multi: true
};
let RangeValidator = class RangeValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = range(this.nbvRange);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvRange') {
                this.validator = range(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvRange';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$l(this.nbvRange, this.nbvRangeValTitle, this.nbvRangeMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
RangeValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], RangeValidator.prototype, "nbvRange", void 0);
__decorate([
    Input()
], RangeValidator.prototype, "dest", void 0);
__decorate([
    Input()
], RangeValidator.prototype, "nbvRangeValTitle", void 0);
__decorate([
    Input()
], RangeValidator.prototype, "nbvRangeMsgHtml", void 0);
RangeValidator = __decorate([
    Directive({
        selector: '[nbvRange][formControlName],[nbvRange][formControl],[nbvRange][ngModel]',
        providers: [RANGE_VALIDATOR]
    })
], RangeValidator);
function getInnerHTML$l(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getRange({ lowerBound: valueTitle[0], upperBound: valueTitle[1] });
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getRange({ lowerBound: value[0], upperBound: value[1] });
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const RANGE_LENGTH_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => RangeLengthValidator),
    multi: true
};
let RangeLengthValidator = class RangeLengthValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = rangeLength(this.nbvRangeLength);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvRangeLength') {
                this.validator = rangeLength(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvRangeLength';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$m(this.nbvRangeLength, this.nbvRangeLengthValTitle, this.nbvRangeLengthMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
RangeLengthValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], RangeLengthValidator.prototype, "nbvRangeLength", void 0);
__decorate([
    Input()
], RangeLengthValidator.prototype, "dest", void 0);
__decorate([
    Input()
], RangeLengthValidator.prototype, "nbvRangeLengthValTitle", void 0);
__decorate([
    Input()
], RangeLengthValidator.prototype, "nbvRangeLengthMsgHtml", void 0);
RangeLengthValidator = __decorate([
    Directive({
        selector: '[nbvRangeLength][formControlName],[nbvRangeLength][formControl],[nbvRangeLength][ngModel]',
        providers: [RANGE_LENGTH_VALIDATOR]
    })
], RangeLengthValidator);
function getInnerHTML$m(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getRangeLength(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getRangeLength(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const URL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => UrlValidator),
    multi: true
};
let UrlValidator = class UrlValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        // return url(c);
        const vClassSuffix = '-nbvUrl';
        const iValidated = url(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$n(this.nbvUrlMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
UrlValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], UrlValidator.prototype, "dest", void 0);
__decorate([
    Input()
], UrlValidator.prototype, "nbvUrlMsgHtml", void 0);
UrlValidator = __decorate([
    Directive({
        selector: '[nbvUrl][formControlName],[nbvUrl][formControl],[nbvUrl][ngModel]',
        providers: [URL_VALIDATOR]
    })
], UrlValidator);
function getInnerHTML$n(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getUrl();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const UUID_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => UUIDValidator),
    multi: true
};
let UUIDValidator = class UUIDValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    ngOnInit() {
        this.validator = uuid(this.nbvUuid);
    }
    ngOnChanges(changes) {
        for (const key in changes) {
            if (key === 'nbvUuid') {
                this.validator = uuid(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    }
    validate(c) {
        // return this.validator(c);
        const vClassSuffix = '-nbvUuid';
        const iValidated = this.validator(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$o(this.nbvUuidMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
    registerOnValidatorChange(fn) {
        this.onChange = fn;
    }
};
UUIDValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], UUIDValidator.prototype, "nbvUuid", void 0);
__decorate([
    Input()
], UUIDValidator.prototype, "dest", void 0);
__decorate([
    Input()
], UUIDValidator.prototype, "nbvUuidMsgHtml", void 0);
UUIDValidator = __decorate([
    Directive({
        selector: '[nbvUuid][formControlName],[nbvUuid][formControl],[nbvUuid][ngModel]',
        providers: [UUID_VALIDATOR]
    })
], UUIDValidator);
function getInnerHTML$o(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getUuid();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

// import {minLength} from './validator';
const MinLength_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => MinlengthValidator),
    multi: true
};
let MinlengthValidator = class MinlengthValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        const vClassSuffix = '-nbvMinlength';
        // Start Method 1 Worked Very Good
        let iValidated = false;
        if (isNullOrUndefined(c.value)) {
            iValidated = false;
        }
        else {
            if (c.value.toString().length === 0) {
                iValidated = false;
            }
            else if (c.value.toString().length < this.nbvMinlength) {
                iValidated = true;
            }
            else {
                iValidated = false;
            }
        }
        // End Method 1 Worked Very Good
        // // Start Method 2
        // const iValidated = minLength(c, this.nbvMinlength);
        // // End Method 2
        if (iValidated) {
            const innerHTML = getInnerHTML$p(this.nbvMinlength, this.nbvMinlengthTitle, this.nbvMinlengthMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
            return { nbvMinlength: true };
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
            return null;
        }
    }
};
MinlengthValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], MinlengthValidator.prototype, "nbvMinlength", void 0);
__decorate([
    Input()
], MinlengthValidator.prototype, "nbvMinlengthTitle", void 0);
__decorate([
    Input()
], MinlengthValidator.prototype, "dest", void 0);
__decorate([
    Input()
], MinlengthValidator.prototype, "nbvMinlengthMsgHtml", void 0);
MinlengthValidator = __decorate([
    Directive({
        selector: '[nbvMinlength][formControlName],[nbvMinlength][formControl],[nbvMinlength][ngModel]',
        providers: [MinLength_VALIDATOR]
    })
], MinlengthValidator);
function getInnerHTML$p(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getMinLength(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getMinLength(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

function isNull(arg) {
    return arg === null;
}
const Required_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => RequiredValidator),
    multi: true
};
let RequiredValidator = class RequiredValidator {
    constructor(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
        this.iValidated = false;
        this.vClassSuffix = '-nbvRequired';
    }
    onBlur() {
        this.manageAlert();
    }
    validate(abstractControl) {
        this.abstractControl = abstractControl;
        // // Start Method 1 Worked Very Good
        // if (isNullOrUndefined(c.value)) {
        //   iValidated = true;
        // } else if (c.value.toString().length === 0) {
        //   iValidated = true;
        // } else {
        //   iValidated = false;
        // }
        // // End Method 1 Worked Very Good
        // Start Method 2 Worked Very Good
        if (isNull(Validators.required(abstractControl))) {
            this.iValidated = false;
        }
        else {
            this.iValidated = Validators.required(abstractControl)['required'];
        }
        return this.manageAlert();
        // End Method 2 Worked Very Good
    }
    manageAlert() {
        if (this.iValidated) {
            if (this.abstractControl.dirty || this.abstractControl.touched || this.submitted) {
                const innerHTML = getInnerHTML$q(this.nbvRequiredMsgHtml, this.nbvRequiredFieldLabel, this._ValidationMessage);
                manageAddValidationAlert(this.dest, this.vClassSuffix, innerHTML, this._ValidationConfig);
            }
            else {
                manageDelValidationAlert(this.dest, this.vClassSuffix);
            }
            return { 'nbvRequired': true };
        }
        else {
            manageDelValidationAlert(this.dest, this.vClassSuffix);
            return null;
        }
    }
    ngOnChanges(changes) {
        if (changes.hasOwnProperty('submitted')) {
            this.mySubmitted = this.submitted;
            if (this.abstractControl) {
                if (this.mySubmitted) {
                    this.abstractControl.markAsTouched();
                }
                else {
                    this.abstractControl.markAsUntouched();
                }
            }
            this.manageAlert();
        }
    }
    registerOnValidatorChange(fn) {
    }
};
RequiredValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], RequiredValidator.prototype, "dest", void 0);
__decorate([
    Input()
], RequiredValidator.prototype, "nbvRequiredMsgHtml", void 0);
__decorate([
    Input()
], RequiredValidator.prototype, "nbvRequiredFieldLabel", void 0);
__decorate([
    Input()
], RequiredValidator.prototype, "submitted", void 0);
__decorate([
    HostListener('blur')
], RequiredValidator.prototype, "onBlur", null);
RequiredValidator = __decorate([
    Directive({
        selector: '[nbvRequired][formControlName],[nbvRequired][formControl],[nbvRequired][ngModel]',
        providers: [Required_VALIDATOR]
    })
], RequiredValidator);
function getInnerHTML$q(msgHtml, nbvRequiredFieldLabel, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getRequired(nbvRequiredFieldLabel);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const MaxLength_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => MaxlengthValidator),
    multi: true
};
let MaxlengthValidator = class MaxlengthValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        const vClassSuffix = '-nbvMaxlength';
        let iValidated = false;
        // alert('c.value.toString().length = ' + c.value.toString().length);
        // alert('this.nbvMinlength = ' + this.nbvMinlength);
        if (isNullOrUndefined(c.value)) {
            iValidated = false;
        }
        else {
            if (c.value.toString().length > this.nbvMaxlength) {
                iValidated = true;
            }
            else {
                iValidated = false;
            }
        }
        if (iValidated) {
            const innerHTML = getInnerHTML$r(this.nbvMaxlength, this.nbvMaxlengthTitle, this.nbvMaxlengthMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
            return { nbvMaxlength: true };
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
            return null;
        }
    }
};
MaxlengthValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], MaxlengthValidator.prototype, "nbvMaxlength", void 0);
__decorate([
    Input()
], MaxlengthValidator.prototype, "nbvMaxlengthTitle", void 0);
__decorate([
    Input()
], MaxlengthValidator.prototype, "dest", void 0);
__decorate([
    Input()
], MaxlengthValidator.prototype, "nbvMaxlengthMsgHtml", void 0);
MaxlengthValidator = __decorate([
    Directive({
        selector: '[nbvMaxlength][formControlName],[nbvMaxlength][formControl],[nbvMaxlength][ngModel]',
        providers: [MaxLength_VALIDATOR]
    })
], MaxlengthValidator);
function getInnerHTML$r(value, valueTitle, msgHtml, _ValidationMessage) {
    let innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        const vMessage = _ValidationMessage.getMaxLength(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        const vMessage = _ValidationMessage.getMaxLength(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const Pattern_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => PatternValidator),
    multi: true
};
let PatternValidator = class PatternValidator {
    constructor(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        const vClassSuffix = '-nbvPattern';
        // const iValidated = pattern(c, this.nbvPattern);
        let iValidated = false;
        if (isNullOrUndefined(c.value)) {
            iValidated = false;
        }
        else {
            if (c.value.toString().length === 0) {
                iValidated = false;
            }
            else if (new RegExp('^' + this.nbvPattern + '$').test(c.value)) {
                iValidated = false;
            }
            else {
                iValidated = true;
            }
        }
        if (iValidated) {
            const innerHTML = getInnerHTML$s(this.nbvPatternMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
            return { 'nbvPattern': true };
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
            return null;
        }
    }
};
PatternValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], PatternValidator.prototype, "nbvPattern", void 0);
__decorate([
    Input()
], PatternValidator.prototype, "dest", void 0);
__decorate([
    Input()
], PatternValidator.prototype, "nbvPatternMsgHtml", void 0);
PatternValidator = __decorate([
    Directive({
        selector: '[nbvPattern][formControlName],[nbvPattern][formControl],[nbvPattern][ngModel]',
        providers: [Pattern_VALIDATOR]
    })
], PatternValidator);
function getInnerHTML$s(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getDefault();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

const NATIONALCODE_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(() => NationalCodeValidator),
    multi: true
};
let NationalCodeValidator = class NationalCodeValidator {
    constructor(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    validate(c) {
        const vClassSuffix = '-nbvNationalCode';
        const iValidated = nationalCode(c);
        if (iValidated) {
            const innerHTML = getInnerHTML$t(this.nbvNationalCodeMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    }
};
NationalCodeValidator.ctorParameters = () => [
    { type: ValidationConfig },
    { type: ValidationMessage }
];
__decorate([
    Input()
], NationalCodeValidator.prototype, "dest", void 0);
__decorate([
    Input()
], NationalCodeValidator.prototype, "nbvNationalCodeMsgHtml", void 0);
NationalCodeValidator = __decorate([
    Directive({
        selector: '[nbvNationalCode][formControlName],[nbvNationalCode][formControl],[nbvNationalCode][ngModel]',
        providers: [NATIONALCODE_VALIDATOR]
    })
], NationalCodeValidator);
function getInnerHTML$t(msgHtml, _ValidationMessage) {
    let innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        const vMessage = _ValidationMessage.getNationalCode();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}
// export  function Fa2En(value: any): any {
//   const englishNumbers = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'];
//   const persianNumbers = ['۱', '۲', '۳', '۴', '۵', '۶', '۷', '۸', '۹', '۰'];
//   if(isNullOrUndefined(value))
//     return value;
//   let myvalue: string = value.toString();
//   if(!isNullOrUndefined(value)) {
//     for (let i = 0, numbersLen = persianNumbers.length; i < numbersLen; i++) {
//       myvalue = myvalue.replace(new RegExp(persianNumbers[i], 'g'), englishNumbers[i]);
//     }
//   }
//   return myvalue;
// }

const NbValidators = {
    arrayLength,
    base64,
    creditCard,
    date,
    dateISO_8601,
    digits,
    email,
    equal,
    equalTo,
    gt,
    gte,
    json,
    lt,
    lte,
    max,
    maxDate,
    min,
    minDate,
    notEqual,
    notEqualTo,
    number,
    property,
    range,
    rangeLength,
    url,
    uuid,
    nationalCode
};
const CustomDirectives = [
    ArrayLengthValidator,
    Base64Validator,
    CreditCardValidator,
    DateValidator,
    DateISOValidator,
    DigitsValidator,
    EmailValidator,
    EqualValidator,
    EqualToValidator,
    GreaterThanValidator,
    GreaterThanEqualValidator,
    JSONValidator,
    LessThanValidator,
    LessThanEqualValidator,
    MaxValidator,
    MaxDateValidator,
    MinValidator,
    MinDateValidator,
    NotEqualValidator,
    NotEqualToValidator,
    NumberValidator,
    PropertyValidator,
    RangeValidator,
    RangeLengthValidator,
    UrlValidator,
    UUIDValidator,
    MinlengthValidator,
    MaxlengthValidator,
    RequiredValidator,
    PatternValidator,
    NationalCodeValidator
];
let NbValidationModule = class NbValidationModule {
};
NbValidationModule = __decorate([
    NgModule({
        declarations: [CustomDirectives],
        exports: [CustomDirectives]
    })
], NbValidationModule);

class CustomPattern {
}
CustomPattern.onlyEnglishLettersWithSpecificLength = class {
    static getPattern(length) {
        return '[a-z]{' + length + '}';
    }
    static getPatternMsgHtml(length) {
        return 'مقدار وارد شده باید حروف انگلیسی و ' + length + ' حرف باشد';
    }
};

class ValidationMessageHelper {
    constructor(title, description) {
        this.title = title;
        this.description = description;
    }
}

/**
 * @author Jafar Amini in March 2018.
 */
class ValidationMessageImpl {
    getGt(value) {
        return new ValidationMessageHelper('عدد وارد شده باید بزرگ‌تر از ' + value + ' باشد', null);
    }
    getGte(value) {
        return new ValidationMessageHelper('عدد وارد شده باید بزرگ‌تر یا مساوی ' + value + ' باشد', null);
    }
    getEqualTo(value) {
        return new ValidationMessageHelper('مقدار وارد شده باید برابر با ' + value + ' باشد', null);
    }
    getNotEqualTo(value) {
        return new ValidationMessageHelper('مقدار وارد شده نباید برابر با ' + value + ' باشد', null);
    }
    getEqual(value) {
        return new ValidationMessageHelper('مقدار وارد شده باید برابر با ' + value + ' باشد', null);
    }
    getNotEqual(value) {
        return new ValidationMessageHelper('مقدار وارد شده نباید برابر با ' + value + ' باشد', null);
    }
    getEmail() {
        return new ValidationMessageHelper('ایمیل وارد شده صحیح نیست', null);
    }
    getUrl() {
        return new ValidationMessageHelper('url وارد شده صحیح نیست', null);
    }
    getUuid() {
        return new ValidationMessageHelper('uuid وارد شده صحیح نیست', null);
    }
    getDigits() {
        return new ValidationMessageHelper('فقط ارقام ریاضی مجاز هستند', null);
    }
    getNumber() {
        return new ValidationMessageHelper('مقدار وارد شده باید عدد باشد', null);
    }
    getDateISO_8601() {
        return new ValidationMessageHelper('فرمت وارد شده صحبح نیست', `<i class="fa fa-info-circle" aria-hidden="true"></i> مثال 2018/02/15
      `);
    }
    getDate() {
        return new ValidationMessageHelper('فرمت وارد شده صحبح نیست', `
<i class="fa fa-info-circle" aria-hidden="true"></i> مثال
`);
    }
    getCreditCard() {
        return new ValidationMessageHelper('کارت اعتباری معتبر نیست', null);
    }
    getBase64() {
        return new ValidationMessageHelper('رشته ورودی base64 نیست', null);
    }
    getJson() {
        return new ValidationMessageHelper('رشته ورودی json نیست', null);
    }
    getLt(value) {
        return new ValidationMessageHelper('عدد وارد شده باید کوچک‌تر از ' + value + ' باشد', null);
    }
    getLte(value) {
        return new ValidationMessageHelper('عدد وارد شده باید کوچک‌تر یا مساوی ' + value + ' باشد', null);
    }
    getMax(value) {
        return new ValidationMessageHelper('مقدار وارد شده نباید بزرگ‌تر از ' + value + ' باشد', null);
    }
    getMaxDate(value) {
        return new ValidationMessageHelper('تاریخ وارد شده نباید بزرگ‌تر از ' + value + ' باشد', null);
    }
    getMin(value) {
        return new ValidationMessageHelper('مقدار وارد شده نباید کوچک‌تر از ' + value + ' باشد', null);
    }
    getMinDate(value) {
        return new ValidationMessageHelper('تاریخ وارد شده نباید کوچک‌تر از ' + value + ' باشد', null);
    }
    getProperty(iValidated) {
        let list;
        list = `<ul>`;
        for (const prop of iValidated.errorProperty) {
            list = list + `<li>` + prop + `</li>`;
        }
        list = list + `</ul>`;
        return new ValidationMessageHelper('برخی propertyها مقدار ندارند', `
      لیست propertyهایی که مقدار ندارند:
      ` + list);
    }
    isDigit(value) {
        return /^([0-9]*)$|^([۰-۹]*)$/.test(value);
    }
    getRange(value) {
        let v0 = this.isDigit(value.lowerBound) === true ? value.lowerBound - 1 : value.lowerBound;
        let v1 = this.isDigit(value.upperBound) === true ? value.upperBound + 1 : value.upperBound;
        return new ValidationMessageHelper('مقدار وارد شده باید بین ' + v0 + ' و ' + v1 + ' باشد', null);
    }
    getRangeLength(value) {
        // alert('isDigit(' + value[0] + ') = ' + this.isDigit(value[0]));
        let v0 = this.isDigit(value[0]) === true ? value[0] - 1 : value[0];
        let v1 = this.isDigit(value[1]) === true ? value[1] + 1 : value[1];
        return new ValidationMessageHelper('طول مقدار وارد شده باید بین ' + v0 + ' و ' + v1 + ' باشد', null);
    }
    getMinLength(value) {
        return new ValidationMessageHelper('طول مقدار وارد شده باید بزرگتر مساوی ' + value + ' باشد', null);
    }
    getMaxLength(value) {
        return new ValidationMessageHelper('طول مقدار وارد شده باید کوچکتر مساوی ' + value + ' باشد', null);
    }
    getRequired(nbvRequiredFieldLabel) {
        if (isNullOrUndefined(nbvRequiredFieldLabel)) {
            return new ValidationMessageHelper('پر کردن این فیلد الزامی است', null);
        }
        else {
            return new ValidationMessageHelper('پر کردن فیلد ' + nbvRequiredFieldLabel + ' الزامی است', null);
        }
    }
    getDefault() {
        return new ValidationMessageHelper('مقدار وارد شده قابل قبول نیست', null);
    }
}

class ValidationOptions {
}

/*
 * Public API Surface of validation
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CustomPattern, NbValidationModule, NbValidators, ValidationComponent, ValidationConfig, ValidationMessage, ValidationMessageHelper, ValidationMessageImpl, ValidationModule, ValidationOptions, ValidationService, ValidationSrcType, addValidationEl, delValidationEl, deleteElementByClassName, getMyValidationElement, isDate, isPresent, manageAddValidationAlert, manageDelValidationAlert, parseDate, arrayLength as ɵa, base64 as ɵb, nationalCode as ɵba, ArrayLengthValidator as ɵbb, Base64Validator as ɵbc, CreditCardValidator as ɵbd, DateValidator as ɵbe, DateISOValidator as ɵbf, DigitsValidator as ɵbg, EmailValidator as ɵbh, EqualValidator as ɵbi, EqualToValidator as ɵbj, GreaterThanValidator as ɵbk, GreaterThanEqualValidator as ɵbl, JSONValidator as ɵbm, LessThanValidator as ɵbn, LessThanEqualValidator as ɵbo, MaxValidator as ɵbp, MaxDateValidator as ɵbq, MinValidator as ɵbr, MinDateValidator as ɵbs, NotEqualValidator as ɵbt, NotEqualToValidator as ɵbu, NumberValidator as ɵbv, PropertyValidator as ɵbw, RangeValidator as ɵbx, RangeLengthValidator as ɵby, UrlValidator as ɵbz, creditCard as ɵc, UUIDValidator as ɵca, MinlengthValidator as ɵcb, MaxlengthValidator as ɵcc, RequiredValidator as ɵcd, PatternValidator as ɵce, NationalCodeValidator as ɵcf, date as ɵd, dateISO_8601 as ɵe, digits as ɵf, email as ɵg, equal as ɵh, equalTo as ɵi, gt as ɵj, gte as ɵk, json as ɵl, lt as ɵm, lte as ɵn, max as ɵo, maxDate as ɵp, min as ɵq, minDate as ɵr, notEqual as ɵs, notEqualTo as ɵt, number as ɵu, property as ɵv, range as ɵw, rangeLength as ɵx, url as ɵy, uuid as ɵz };
//# sourceMappingURL=angular-boot-validation.js.map
