import { __decorate, __values } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Component, NgModule, forwardRef, Input, Directive, HostListener } from '@angular/core';
import { Validators, FormControl, NgModel, NG_VALIDATORS } from '@angular/forms';
import { isNullOrUndefined } from '@angular-boot/util';

var ValidationService = /** @class */ (function () {
    function ValidationService() {
    }
    ValidationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ValidationService_Factory() { return new ValidationService(); }, token: ValidationService, providedIn: "root" });
    ValidationService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], ValidationService);
    return ValidationService;
}());

var ValidationComponent = /** @class */ (function () {
    function ValidationComponent() {
    }
    ValidationComponent.prototype.ngOnInit = function () {
    };
    ValidationComponent = __decorate([
        Component({
            selector: 'lib-validation',
            template: "\n    <p>\n      validation works!\n    </p>\n  "
        })
    ], ValidationComponent);
    return ValidationComponent;
}());

var ValidationModule = /** @class */ (function () {
    function ValidationModule() {
    }
    ValidationModule = __decorate([
        NgModule({
            declarations: [ValidationComponent],
            imports: [],
            exports: [ValidationComponent]
        })
    ], ValidationModule);
    return ValidationModule;
}());

function isPresent(obj) {
    return obj !== undefined && obj !== null;
}
function isDate(obj) {
    return !/Invalid|NaN/.test(new Date(obj).toString());
}
function parseDate(obj) {
    try {
        if (typeof obj === 'object' && obj.year != null && obj.month != null && obj.day != null) {
            return obj.year + '-' + obj.month + '-' + obj.day;
        }
    }
    catch (e) { }
    return obj;
}
// -----------------------------
function deleteElementByClassName(className) {
    var elements = document.getElementsByClassName(className);
    while (elements.length > 0) {
        elements[0].parentNode.removeChild(elements[0]);
    }
}
// -----------------------------
// -----------------------------
function addValidationEl(dest, vClassSuffix, innerHtml, _ValidationConfig) {
    deleteElementByClassName(dest + vClassSuffix);
    document.getElementById(dest).appendChild(getMyValidationElement(dest, vClassSuffix, innerHtml, _ValidationConfig));
}
function delValidationEl(dest, vClassSuffix) {
    deleteElementByClassName(dest + vClassSuffix);
}
function getMyValidationElement(dest, vClassSuffix, innerHtml, _ValidationConfig) {
    var myEl = _ValidationConfig.getValidationAlertElement(dest + vClassSuffix);
    myEl.innerHTML = innerHtml;
    return myEl;
}
// -----------------------------
// export function getValidationAlertElement(vClass): HTMLElement {
//   const myAlert: HTMLElement = document.createElement('div');
//   myAlert.classList.add('alert');
//   myAlert.classList.add('alert-danger');
//   myAlert.classList.add(vClass);
//   return myAlert;
// }
// -----------------------------
// export function addValidationElComplex(dest, vClassSuffix, value, valueTitle) {
//   deleteElementByClassName(dest + vClassSuffix);
//   document.getElementById(dest).appendChild(getMyValidationElementComplex(dest, vClassSuffix, value, valueTitle));
// }
// export function getMyValidationElementComplex(dest, vClassSuffix, value, valueTitle) {
//   const myEl = getValidationAlertElement(dest + vClassSuffix);
//   if (!isNullOrUndefined(valueTitle)) {
//     myEl.innerHTML = new ValidationMessage().getEqual(valueTitle);
//   } else {
//     myEl.innerHTML = new ValidationMessage().getEqual(value);
//   }
//   return myEl;
// }
// -----------------------------
// -----------------------------
function manageDelValidationAlert(dest, vClassSuffix) {
    if (!isNullOrUndefined(dest)) {
        delValidationEl(dest, vClassSuffix);
    }
}
function manageAddValidationAlert(dest, vClassSuffix, innerHTML, _ValidationConfig) {
    if (!isNullOrUndefined(dest)) {
        addValidationEl(dest, vClassSuffix, innerHTML, _ValidationConfig);
    }
}
// -----------------------------

var arrayLength = function (value) {
    return function (control) {
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var obj = control.value;
        return Array.isArray(obj) && obj.length >= +value ? null : { arrayLength: +value };
    };
};

var base64 = function (control) {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    var v = control.value;
    return /^(?:[A-Z0-9+\/]{4})*(?:[A-Z0-9+\/]{2}==|[A-Z0-9+\/]{3}=|[A-Z0-9+\/]{4})$/i.test(v) ? null : { 'nbvBase64': true };
};

var creditCard = function (control) {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    var v = control.value;
    var sanitized = v.replace(/[^0-9]+/g, '');
    // problem with chrome
    /* tslint:disable */
    if (!(/^(?:4[0-9]{12}(?:[0-9]{3})?|5[1-5][0-9]{14}|6(?:011|5[0-9][0-9])[0-9]{12}|3[47][0-9]{13}|3(?:0[0-5]|[68][0-9])[0-9]{11}|(?:2131|1800|35\d{3})\d{11}|(?:9792)\d{12})$/.test(sanitized))) {
        return { nbvCreditCard: true };
    }
    /* tslint:enable */
    var sum = 0;
    var digit;
    var tmpNum;
    var shouldDouble;
    for (var i = sanitized.length - 1; i >= 0; i--) {
        digit = sanitized.substring(i, (i + 1));
        tmpNum = parseInt(digit, 10);
        if (shouldDouble) {
            tmpNum *= 2;
            if (tmpNum >= 10) {
                sum += ((tmpNum % 10) + 1);
            }
            else {
                sum += tmpNum;
            }
        }
        else {
            sum += tmpNum;
        }
        shouldDouble = !shouldDouble;
    }
    if (Boolean((sum % 10) === 0 ? sanitized : false)) {
        return null;
    }
    return { nbvCreditCard: true };
};

var date = function (control) {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    var v = control.value;
    return isDate(v) ? null : { nbvDate: true };
};

var dateISO_8601 = function (control) {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    var v = control.value;
    return /^\d{4}[\/\-](0?[1-9]|1[012])[\/\-](0?[1-9]|[12][0-9]|3[01])$|^[۰-۹]{4}[\/\-](۰?[۱-۹]|۱[۰۱۲])[\/\-](۰?[۱-۹]|[۱۲][۰-۹]|۳[۰۱])$/.test(v) ? null : { nbvDateISO_8601: true };
};

var digits = function (control) {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    var v = control.value;
    // return /^\d+$/.test(v) ? null : {digits: true};
    return /^([0-9]*)$|^([۰-۹]*)$/.test(v) ? null : { nbvDigits: true };
};

var nationalCode = function (control) {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    var v = control.value;
    if (isValidNationalCode(v)) {
        return null;
    }
    else {
        return { nationalCode: true };
    }
};
function isValidNationalCode(value) {
    var isValid = false;
    if (!/^\d{10}$/.test(value)) {
        isValid = false;
    }
    else {
        var check = +value[9];
        var sum = 0;
        var i = void 0;
        for (i = 0; i < 9; ++i) {
            sum += (+value[i]) * (10 - i);
        }
        sum %= 11;
        if ((sum < 2 && check === sum) || (sum >= 2 && check + sum === 11)) {
            isValid = true;
        }
    }
    return isValid;
}

var email = function (control) {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    var v = control.value;
    /* tslint:disable */
    return /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(v) ? null : { 'nbvEmail': true };
    /* tslint:enable */
};

var equal = function (val) {
    return function (control) {
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = control.value;
        return val === v ? null : { nbvEqual: true };
    };
};

var equalTo = function (equalControl) {
    var subscribe = false;
    return function (control) {
        if (!subscribe) {
            subscribe = true;
            equalControl.valueChanges.subscribe(function () {
                control.updateValueAndValidity();
            });
        }
        var v = control.value;
        return equalControl.value === v ? null : { nbvEqualTo: true };
    };
};

var gt = function (value) {
    return function (control) {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = +control.value;
        return v > +value ? null : { nbvGt: true };
    };
};

var gte = function (value) {
    return function (control) {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = +control.value;
        return v >= +value ? null : { nbvGte: true };
    };
};

var json = function (control) {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    var v = control.value;
    try {
        var obj = JSON.parse(v);
        if (Boolean(obj) && typeof obj === 'object') {
            return null;
        }
    }
    catch (e) { }
    return { nbvJson: true };
};

var lt = function (value) {
    return function (control) {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = +control.value;
        return v < +value ? null : { nbvLt: true };
    };
};

var lte = function (value) {
    return function (control) {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = +control.value;
        return v <= +value ? null : { nbvLte: true };
    };
};

var max = function (value) {
    return function (control) {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = +control.value;
        return v <= +value ? null : { actualValue: v, requiredValue: +value, nbvMax: true };
    };
};

var maxDate = function (maxInput) {
    var value;
    var subscribe = false;
    var maxValue = maxInput;
    var isForm = maxInput instanceof FormControl || maxInput instanceof NgModel;
    return function (control) {
        if (!subscribe && isForm) {
            subscribe = true;
            maxInput.valueChanges.subscribe(function () {
                control.updateValueAndValidity();
            });
        }
        if (isForm) {
            maxValue = maxInput.value;
        }
        value = parseDate(maxValue);
        if (!isDate(value) && !(value instanceof Function)) {
            if (value == null) {
                return null;
            }
            else if (isForm) {
                return { nbvMaxDate: true, error: 'maxDate is invalid' };
            }
            else {
                throw Error('maxDate value must be or return a formatted date');
            }
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var d = new Date(parseDate(control.value)).getTime();
        if (!isDate(d)) {
            return { value: true };
        }
        if (value instanceof Function) {
            value = value();
        }
        return d <= new Date(value).getTime() ? null : { nbvMaxDate: true, error: 'greater than maxDate' };
    };
};

var min = function (value) {
    return function (control) {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = +control.value;
        return v >= +value ? null : { actualValue: v, requiredValue: +value, nbvMin: true };
    };
};

var minDate = function (minInput) {
    var value;
    var subscribe = false;
    var minValue = minInput;
    var isForm = minInput instanceof FormControl || minInput instanceof NgModel;
    return function (control) {
        if (!subscribe && isForm) {
            subscribe = true;
            minInput.valueChanges.subscribe(function () {
                control.updateValueAndValidity();
            });
        }
        if (isForm) {
            minValue = minInput.value;
        }
        value = parseDate(minValue);
        if (!isDate(value) && !(value instanceof Function)) {
            if (value == null) {
                return null;
            }
            else if (isForm) {
                return { nbvMinDate: true, error: 'minDate is invalid' };
            }
            else {
                throw Error('minDate value must be or return a formatted date');
            }
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var d = new Date(parseDate(control.value)).getTime();
        if (!isDate(d)) {
            return { value: true };
        }
        if (value instanceof Function) {
            value = value();
        }
        return d >= new Date(value).getTime() ? null : { nbvMinDate: true, error: 'lower than minDate' };
    };
};

var notEqual = function (val) {
    return function (control) {
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = control.value;
        return val !== v ? null : { nbvNotEqual: true };
    };
};

/**
 * @author Jafar Amini in March 2018.
 */
var ValidationSrcType;
(function (ValidationSrcType) {
    ValidationSrcType[ValidationSrcType["FormControl"] = 'FormControl'] = "FormControl";
    ValidationSrcType[ValidationSrcType["CustomValue"] = 'CustomValue'] = "CustomValue";
})(ValidationSrcType || (ValidationSrcType = {}));

/**
 * Edited by Jafar Amini in March 2018.
 */
var notEqualTo = function (notEqualControl, validationOptions) {
    var subscribe = false;
    return function (control) {
        var v = control.value;
        // alert(typeof notEqualControl);
        if (!isNullOrUndefined(validationOptions) &&
            validationOptions.validationSrcType === ValidationSrcType.FormControl) {
            if (!subscribe) {
                subscribe = true;
                notEqualControl.valueChanges.subscribe(function () {
                    control.updateValueAndValidity();
                });
            }
            return notEqualControl.value !== v ? null : { nbvNotEqualTo: true };
        }
        else if (!isNullOrUndefined(validationOptions) &&
            validationOptions.validationSrcType === ValidationSrcType.CustomValue) {
            if (isPresent(Validators.required(control))) {
                return null;
            }
            return notEqualControl !== v ? null : { nbvNotEqualTo: true };
        }
        else {
            if (isPresent(Validators.required(control))) {
                return null;
            }
            return notEqualControl !== v ? null : { nbvNotEqualTo: true };
        }
    };
};

var number = function (control) {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    var v = control.value;
    return /^(?:-?\d+|-?\d{1,3}(?:,\d{3})+)?(?:\.\d+)?$/.test(v) ? null : { 'nbvNumber': true };
};

var property = function (value) {
    return function (control) {
        var e_1, _a;
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var properties = value.split(',');
        var errorProperty = new Array();
        var obj = control.value;
        var isValid = true;
        try {
            for (var properties_1 = __values(properties), properties_1_1 = properties_1.next(); !properties_1_1.done; properties_1_1 = properties_1.next()) {
                var prop = properties_1_1.value;
                if (isNullOrUndefined(obj[prop])) {
                    isValid = false;
                    // break;
                    errorProperty.push(prop);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (properties_1_1 && !properties_1_1.done && (_a = properties_1.return)) _a.call(properties_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return isValid ? null : { hasProperty: true, nbvProperty: value, errorProperty: errorProperty };
    };
};

var range = function (value) {
    return function (control) {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = +control.value;
        return v >= value[0] && v <= value[1] ? null : { actualValue: v, requiredValue: value, nbvRange: true };
    };
};

var rangeLength = function (value) {
    return function (control) {
        if (!isPresent(value)) {
            return null;
        }
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = control.value;
        return v.length >= value[0] && v.length <= value[1] ? null : { nbvRangeLength: true };
    };
};

var uuids = {
    '3': /^[0-9A-F]{8}-[0-9A-F]{4}-3[0-9A-F]{3}-[0-9A-F]{4}-[0-9A-F]{12}$/i,
    '4': /^[0-9A-F]{8}-[0-9A-F]{4}-4[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    '5': /^[0-9A-F]{8}-[0-9A-F]{4}-5[0-9A-F]{3}-[89AB][0-9A-F]{3}-[0-9A-F]{12}$/i,
    'all': /^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i
};
var uuid = function (version) {
    return function (control) {
        if (isPresent(Validators.required(control))) {
            return null;
        }
        var v = control.value;
        var pattern = uuids[version] || uuids.all;
        return (new RegExp(pattern)).test(v) ? null : { nbvUuid: true };
    };
};

var url = function (control) {
    if (isPresent(Validators.required(control))) {
        return null;
    }
    var v = control.value;
    /* tslint:disable */
    return /^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})).?)(?::\d{2,5})?(?:[/?#]\S*)?$/i.test(v) ? null : { 'nbvUrl': true };
    /* tslint:enable */
};

var ARRAY_LENGTH_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return ArrayLengthValidator; }),
    multi: true
};
var ArrayLengthValidator = /** @class */ (function () {
    function ArrayLengthValidator() {
    }
    ArrayLengthValidator.prototype.ngOnInit = function () {
        this.validator = arrayLength(this.arrayLength);
    };
    ArrayLengthValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'arrayLength') {
                this.validator = arrayLength(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    ArrayLengthValidator.prototype.validate = function (c) {
        return this.validator(c);
    };
    ArrayLengthValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    __decorate([
        Input()
    ], ArrayLengthValidator.prototype, "arrayLength", void 0);
    ArrayLengthValidator = __decorate([
        Directive({
            selector: '[arrayLength][formControlName],[arrayLength][formControl],[arrayLength][ngModel]',
            providers: [ARRAY_LENGTH_VALIDATOR]
        })
    ], ArrayLengthValidator);
    return ArrayLengthValidator;
}());

var ValidationMessage = /** @class */ (function () {
    function ValidationMessage() {
    }
    return ValidationMessage;
}());

/**
 * @author Jafar Amini in March 2018.
 */
var ValidationConfig = /** @class */ (function () {
    function ValidationConfig() {
    }
    return ValidationConfig;
}());

var BASE64_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return Base64Validator; }),
    multi: true
};
var Base64Validator = /** @class */ (function () {
    function Base64Validator(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    Base64Validator.prototype.validate = function (c) {
        // return base64(c);
        var vClassSuffix = '-nbvBase64';
        var iValidated = base64(c);
        if (iValidated) {
            var innerHTML = getInnerHTML(this.nbvBase64MsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    Base64Validator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], Base64Validator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], Base64Validator.prototype, "nbvBase64MsgHtml", void 0);
    Base64Validator = __decorate([
        Directive({
            selector: '[nbvBase64][formControlName],[nbvBase64][formControl],[nbvBase64][ngModel]',
            providers: [BASE64_VALIDATOR]
        })
    ], Base64Validator);
    return Base64Validator;
}());
function getInnerHTML(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getBase64();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var CREDIT_CARD_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return CreditCardValidator; }),
    multi: true
};
var CreditCardValidator = /** @class */ (function () {
    function CreditCardValidator(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    CreditCardValidator.prototype.validate = function (c) {
        // return creditCard(c);
        var vClassSuffix = '-nbvCreditCard';
        var iValidated = creditCard(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$1(this.nbvCreditCardMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    CreditCardValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], CreditCardValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], CreditCardValidator.prototype, "nbvCreditCardMsgHtml", void 0);
    CreditCardValidator = __decorate([
        Directive({
            selector: '[nbvCreditCard][formControlName],[nbvCreditCard][formControl],[nbvCreditCard][ngModel]',
            providers: [CREDIT_CARD_VALIDATOR]
        })
    ], CreditCardValidator);
    return CreditCardValidator;
}());
function getInnerHTML$1(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getCreditCard();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var DATE_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return DateValidator; }),
    multi: true
};
var DateValidator = /** @class */ (function () {
    function DateValidator(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    DateValidator.prototype.validate = function (c) {
        // return date(c);
        var vClassSuffix = '-nbvDate';
        var iValidated = date(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$2(this.nbvDateMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    DateValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], DateValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], DateValidator.prototype, "nbvDateMsgHtml", void 0);
    DateValidator = __decorate([
        Directive({
            selector: '[nbvDate][formControlName],[nbvDate][formControl],[nbvDate][ngModel]',
            providers: [DATE_VALIDATOR]
        })
    ], DateValidator);
    return DateValidator;
}());
function getInnerHTML$2(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getDate();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var DATE_ISO_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return DateISOValidator; }),
    multi: true
};
var DateISOValidator = /** @class */ (function () {
    function DateISOValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    DateISOValidator.prototype.validate = function (c) {
        var vClassSuffix = '-nbvDateISO_8601';
        var iValidated = dateISO_8601(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$3(this.nbvDateISO_8601MsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    DateISOValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], DateISOValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], DateISOValidator.prototype, "nbvDateISO_8601MsgHtml", void 0);
    DateISOValidator = __decorate([
        Directive({
            selector: '[nbvDateISO_8601][formControlName],[nbvDateISO_8601][formControl],[nbvDateISO_8601][ngModel]',
            providers: [DATE_ISO_VALIDATOR]
        })
    ], DateISOValidator);
    return DateISOValidator;
}());
function getInnerHTML$3(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getDateISO_8601();
        innerHTML = vMessage.title + '<br/>' + vMessage.description;
    }
    return innerHTML;
}

var DIGITS_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return DigitsValidator; }),
    multi: true
};
var DigitsValidator = /** @class */ (function () {
    function DigitsValidator(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    DigitsValidator.prototype.validate = function (c) {
        var vClassSuffix = '-nbvDigits';
        var iValidated = digits(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$4(this.nbvDigitsMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    DigitsValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], DigitsValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], DigitsValidator.prototype, "nbvDigitsMsgHtml", void 0);
    DigitsValidator = __decorate([
        Directive({
            selector: '[nbvDigits][formControlName],[nbvDigits][formControl],[nbvDigits][ngModel]',
            providers: [DIGITS_VALIDATOR]
        })
    ], DigitsValidator);
    return DigitsValidator;
}());
function getInnerHTML$4(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getDigits();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}
// export  function Fa2En(value: any): any {
//   const englishNumbers = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'];
//   const persianNumbers = ['۱', '۲', '۳', '۴', '۵', '۶', '۷', '۸', '۹', '۰'];
//   if(isNullOrUndefined(value))
//     return value;
//   let myvalue: string = value.toString();
//   if(!isNullOrUndefined(value)) {
//     for (let i = 0, numbersLen = persianNumbers.length; i < numbersLen; i++) {
//       myvalue = myvalue.replace(new RegExp(persianNumbers[i], 'g'), englishNumbers[i]);
//     }
//   }
//   return myvalue;
// }

var EMAIL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return EmailValidator; }),
    multi: true
};
var EmailValidator = /** @class */ (function () {
    function EmailValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    EmailValidator.prototype.validate = function (c) {
        var vClassSuffix = '-nbvEmail';
        var iValidated = email(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$5(this.nbvEmailMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    EmailValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], EmailValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], EmailValidator.prototype, "nbvEmailMsgHtml", void 0);
    EmailValidator = __decorate([
        Directive({
            selector: '[nbvEmail][formControlName],[nbvEmail][formControl],[nbvEmail][ngModel]',
            providers: [EMAIL_VALIDATOR]
        })
    ], EmailValidator);
    return EmailValidator;
}());
function getInnerHTML$5(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getEmail();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var EQUAL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return EqualValidator; }),
    multi: true
};
var EqualValidator = /** @class */ (function () {
    function EqualValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    EqualValidator.prototype.ngOnInit = function () {
        this.validator = equal(this.nbvEqual);
    };
    EqualValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvEqual') {
                this.validator = equal(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    EqualValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvEqual';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$6(this.nbvEqual, this.nbvEqualٰValueTitle, this.nbvEqualMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    EqualValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    EqualValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], EqualValidator.prototype, "nbvEqual", void 0);
    __decorate([
        Input()
    ], EqualValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], EqualValidator.prototype, "nbvEqual\u0670ValueTitle", void 0);
    __decorate([
        Input()
    ], EqualValidator.prototype, "nbvEqualMsgHtml", void 0);
    EqualValidator = __decorate([
        Directive({
            selector: '[nbvEqual][formControlName],[nbvEqual][formControl],[nbvEqual][ngModel]',
            providers: [EQUAL_VALIDATOR]
        })
    ], EqualValidator);
    return EqualValidator;
}());
function getInnerHTML$6(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getEqual(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getEqual(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var EQUAL_TO_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return EqualToValidator; }),
    multi: true
};
var EqualToValidator = /** @class */ (function () {
    function EqualToValidator(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    EqualToValidator.prototype.ngOnInit = function () {
        this.validator = equalTo(this.nbvEqualTo);
    };
    EqualToValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvEqualTo';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$7(this.nbvEqualTo, this.nbvEqualToValTitle, this.nbvEqualToMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    EqualToValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], EqualToValidator.prototype, "nbvEqualTo", void 0);
    __decorate([
        Input()
    ], EqualToValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], EqualToValidator.prototype, "nbvEqualToValTitle", void 0);
    __decorate([
        Input()
    ], EqualToValidator.prototype, "nbvEqualToMsgHtml", void 0);
    EqualToValidator = __decorate([
        Directive({
            selector: '[nbvEqualTo][formControlName],[nbvEqualTo][formControl],[nbvEqualTo][ngModel]',
            providers: [EQUAL_TO_VALIDATOR]
        })
    ], EqualToValidator);
    return EqualToValidator;
}());
function getInnerHTML$7(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getEqualTo(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getEqualTo(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var GREATER_THAN_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return GreaterThanValidator; }),
    multi: true
};
var GreaterThanValidator = /** @class */ (function () {
    function GreaterThanValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    GreaterThanValidator.prototype.ngOnInit = function () {
        this.validator = gt(this.nbvGt);
    };
    GreaterThanValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvGt') {
                this.validator = gt(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
            // if (key === 'des') {
            //   alert(this.des);
            // }
        }
    };
    GreaterThanValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvGt';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$8(this.nbvGt, this.nbvGtٰValTitle, this.nbvGtMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    GreaterThanValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    GreaterThanValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], GreaterThanValidator.prototype, "nbvGt", void 0);
    __decorate([
        Input()
    ], GreaterThanValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], GreaterThanValidator.prototype, "nbvGt\u0670ValTitle", void 0);
    __decorate([
        Input()
    ], GreaterThanValidator.prototype, "nbvGtMsgHtml", void 0);
    GreaterThanValidator = __decorate([
        Directive({
            selector: '[nbvGt][formControlName],[nbvGt][formControl],[nbvGt][ngModel]',
            providers: [GREATER_THAN_VALIDATOR]
        })
    ], GreaterThanValidator);
    return GreaterThanValidator;
}());
function getInnerHTML$8(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getGt(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getGt(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var GREATER_THAN_EQUAL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return GreaterThanEqualValidator; }),
    multi: true
};
var GreaterThanEqualValidator = /** @class */ (function () {
    function GreaterThanEqualValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    GreaterThanEqualValidator.prototype.ngOnInit = function () {
        this.validator = gte(this.nbvGte);
    };
    GreaterThanEqualValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvGte') {
                this.validator = gte(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    GreaterThanEqualValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvGte';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$9(this.nbvGte, this.nbvGteٰValTitle, this.nbvGteMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    GreaterThanEqualValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    GreaterThanEqualValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], GreaterThanEqualValidator.prototype, "nbvGte", void 0);
    __decorate([
        Input()
    ], GreaterThanEqualValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], GreaterThanEqualValidator.prototype, "nbvGte\u0670ValTitle", void 0);
    __decorate([
        Input()
    ], GreaterThanEqualValidator.prototype, "nbvGteMsgHtml", void 0);
    GreaterThanEqualValidator = __decorate([
        Directive({
            selector: '[nbvGte][formControlName],[nbvGte][formControl],[nbvGte][ngModel]',
            providers: [GREATER_THAN_EQUAL_VALIDATOR]
        })
    ], GreaterThanEqualValidator);
    return GreaterThanEqualValidator;
}());
function getInnerHTML$9(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getGte(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getGte(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var JSON_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return JSONValidator; }),
    multi: true
};
var JSONValidator = /** @class */ (function () {
    function JSONValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    JSONValidator.prototype.validate = function (c) {
        // return json(c);
        var vClassSuffix = '-nbvJson';
        var iValidated = json(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$a(this.nbvJsonMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    JSONValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], JSONValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], JSONValidator.prototype, "nbvJsonMsgHtml", void 0);
    JSONValidator = __decorate([
        Directive({
            selector: '[nbvJson][formControlName],[nbvJson][formControl],[nbvJson][ngModel]',
            providers: [JSON_VALIDATOR]
        })
    ], JSONValidator);
    return JSONValidator;
}());
function getInnerHTML$a(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getJson();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var LESS_THAN_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return LessThanValidator; }),
    multi: true
};
var LessThanValidator = /** @class */ (function () {
    function LessThanValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    LessThanValidator.prototype.ngOnInit = function () {
        this.validator = lt(this.nbvLt);
    };
    LessThanValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvLt') {
                this.validator = lt(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    LessThanValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvLt';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$b(this.nbvLt, this.nbvLtValTitle, this.nbvLtMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    LessThanValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    LessThanValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], LessThanValidator.prototype, "nbvLt", void 0);
    __decorate([
        Input()
    ], LessThanValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], LessThanValidator.prototype, "nbvLtValTitle", void 0);
    __decorate([
        Input()
    ], LessThanValidator.prototype, "nbvLtMsgHtml", void 0);
    LessThanValidator = __decorate([
        Directive({
            selector: '[nbvLt][formControlName],[nbvLt][formControl],[nbvLt][ngModel]',
            providers: [LESS_THAN_VALIDATOR]
        })
    ], LessThanValidator);
    return LessThanValidator;
}());
function getInnerHTML$b(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getLt(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getLt(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var LESS_THAN_EQUAL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return LessThanEqualValidator; }),
    multi: true
};
var LessThanEqualValidator = /** @class */ (function () {
    function LessThanEqualValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    LessThanEqualValidator.prototype.ngOnInit = function () {
        this.validator = lte(this.nbvLte);
    };
    LessThanEqualValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvLte') {
                this.validator = lte(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    LessThanEqualValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvLte';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$c(this.nbvLte, this.nbvLteٰValTitle, this.nbvLteMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    LessThanEqualValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    LessThanEqualValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], LessThanEqualValidator.prototype, "nbvLte", void 0);
    __decorate([
        Input()
    ], LessThanEqualValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], LessThanEqualValidator.prototype, "nbvLte\u0670ValTitle", void 0);
    __decorate([
        Input()
    ], LessThanEqualValidator.prototype, "nbvLteMsgHtml", void 0);
    LessThanEqualValidator = __decorate([
        Directive({
            selector: '[nbvLte][formControlName],[nbvLte][formControl],[nbvLte][ngModel]',
            providers: [LESS_THAN_EQUAL_VALIDATOR]
        })
    ], LessThanEqualValidator);
    return LessThanEqualValidator;
}());
function getInnerHTML$c(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getLte(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getLte(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var MAX_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return MaxValidator; }),
    multi: true
};
var MaxValidator = /** @class */ (function () {
    function MaxValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    MaxValidator.prototype.ngOnInit = function () {
        this.validator = max(this.nbvMax);
    };
    MaxValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvMax') {
                this.validator = max(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    MaxValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvMax';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$d(this.nbvMax, this.nbvMaxValTitle, this.nbvMaxMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    MaxValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    MaxValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], MaxValidator.prototype, "nbvMax", void 0);
    __decorate([
        Input()
    ], MaxValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], MaxValidator.prototype, "nbvMaxValTitle", void 0);
    __decorate([
        Input()
    ], MaxValidator.prototype, "nbvMaxMsgHtml", void 0);
    MaxValidator = __decorate([
        Directive({
            selector: '[nbvMax][formControlName],[nbvMax][formControl],[nbvMax][ngModel]',
            providers: [MAX_VALIDATOR]
        })
    ], MaxValidator);
    return MaxValidator;
}());
function getInnerHTML$d(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getMax(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getMax(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var MAX_DATE_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return MaxDateValidator; }),
    multi: true
};
var MaxDateValidator = /** @class */ (function () {
    function MaxDateValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    MaxDateValidator.prototype.ngOnInit = function () {
        this.validator = maxDate(this.nbvMaxDate);
    };
    MaxDateValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvMaxDate') {
                this.validator = maxDate(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    MaxDateValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvMaxDate';
        var iValidated = this.validator(c);
        if (iValidated) {
            console.log('this.maxDate --->', this.nbvMaxDate);
            var innerHTML = getInnerHTML$e(this.nbvMaxDate.value, this.nbvMaxDateValTitle, this.nbvMaxDateMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    MaxDateValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    MaxDateValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], MaxDateValidator.prototype, "nbvMaxDate", void 0);
    __decorate([
        Input()
    ], MaxDateValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], MaxDateValidator.prototype, "nbvMaxDateValTitle", void 0);
    __decorate([
        Input()
    ], MaxDateValidator.prototype, "nbvMaxDateMsgHtml", void 0);
    MaxDateValidator = __decorate([
        Directive({
            selector: '[nbvMaxDate][formControlName],[nbvMaxDate][formControl],[nbvMaxDate][ngModel]',
            providers: [MAX_DATE_VALIDATOR]
        })
    ], MaxDateValidator);
    return MaxDateValidator;
}());
function getInnerHTML$e(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getMaxDate(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getMaxDate(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var MIN_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return MinValidator; }),
    multi: true
};
var MinValidator = /** @class */ (function () {
    function MinValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    MinValidator.prototype.ngOnInit = function () {
        this.validator = min(this.nbvMin);
    };
    MinValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvMin') {
                this.validator = min(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    MinValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvMin';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$f(this.nbvMin, this.nbvMinValTitle, this.nbvMinMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    MinValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    MinValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], MinValidator.prototype, "nbvMin", void 0);
    __decorate([
        Input()
    ], MinValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], MinValidator.prototype, "nbvMinValTitle", void 0);
    __decorate([
        Input()
    ], MinValidator.prototype, "nbvMinMsgHtml", void 0);
    MinValidator = __decorate([
        Directive({
            selector: '[nbvMin][formControlName],[nbvMin][formControl],[nbvMin][ngModel]',
            providers: [MIN_VALIDATOR]
        })
    ], MinValidator);
    return MinValidator;
}());
function getInnerHTML$f(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getMin(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getMin(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var MIN_DATE_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return MinDateValidator; }),
    multi: true
};
var MinDateValidator = /** @class */ (function () {
    function MinDateValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    MinDateValidator.prototype.ngOnInit = function () {
        this.validator = minDate(this.nbvMinDate);
    };
    MinDateValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvMinDate') {
                this.validator = minDate(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    MinDateValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvMinDate';
        var iValidated = this.validator(c);
        if (iValidated) {
            // console.log('this.minDate --> ', this.nbvMinDate);
            var innerHTML = getInnerHTML$g(this.nbvMinDate.year, this.nbvMinDateValTitle, this.nbvMinDateMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    MinDateValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    MinDateValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], MinDateValidator.prototype, "nbvMinDate", void 0);
    __decorate([
        Input()
    ], MinDateValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], MinDateValidator.prototype, "nbvMinDateValTitle", void 0);
    __decorate([
        Input()
    ], MinDateValidator.prototype, "nbvMinDateMsgHtml", void 0);
    MinDateValidator = __decorate([
        Directive({
            selector: '[nbvMinDate][formControlName],[nbvMinDate][formControl],[nbvMinDate][ngModel]',
            providers: [MIN_DATE_VALIDATOR]
        })
    ], MinDateValidator);
    return MinDateValidator;
}());
function getInnerHTML$g(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getMinDate(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getMinDate(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var NOT_EQUAL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return NotEqualValidator; }),
    multi: true
};
var NotEqualValidator = /** @class */ (function () {
    function NotEqualValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    NotEqualValidator.prototype.ngOnInit = function () {
        this.validator = notEqual(this.nbvNotEqual);
    };
    NotEqualValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvNotEqual') {
                this.validator = notEqual(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    NotEqualValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvNotEqual';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$h(this.nbvNotEqual, this.nbvNotEqualValueTitle, this.nbvNotEqualMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    NotEqualValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    NotEqualValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], NotEqualValidator.prototype, "nbvNotEqual", void 0);
    __decorate([
        Input()
    ], NotEqualValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], NotEqualValidator.prototype, "nbvNotEqualValueTitle", void 0);
    __decorate([
        Input()
    ], NotEqualValidator.prototype, "nbvNotEqualMsgHtml", void 0);
    NotEqualValidator = __decorate([
        Directive({
            selector: '[nbvNotEqual][formControlName],[nbvNotEqual][formControl],[nbvNotEqual][ngModel]',
            providers: [NOT_EQUAL_VALIDATOR]
        })
    ], NotEqualValidator);
    return NotEqualValidator;
}());
function getInnerHTML$h(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getNotEqual(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getNotEqual(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var NOT_EQUAL_TO_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return NotEqualToValidator; }),
    multi: true
};
var NotEqualToValidator = /** @class */ (function () {
    function NotEqualToValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    NotEqualToValidator.prototype.ngOnInit = function () {
        this.validator = notEqualTo(this.nbvNotEqualTo, this.validationOptions);
    };
    NotEqualToValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvNotEqualTo') {
                this.validator = notEqualTo(changes[key].currentValue, this.validationOptions);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    NotEqualToValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvNotEqualTo';
        var iValidated = this.validator(c);
        if (iValidated) {
            var tmpV = void 0;
            // alert('OOOOOOOOO------>' + typeof this.notEqualTo);
            if (!isNullOrUndefined(this.validationOptions) &&
                this.validationOptions.validationSrcType === ValidationSrcType.FormControl) {
                tmpV = this.nbvNotEqualTo.value;
            }
            else if (!isNullOrUndefined(this.validationOptions) &&
                this.validationOptions.validationSrcType === ValidationSrcType.CustomValue) {
                tmpV = this.nbvNotEqualTo;
            }
            else {
                tmpV = this.nbvNotEqualTo;
            }
            var innerHTML = getInnerHTML$i(tmpV, this.nbvNotEqualToValTitle, this.nbvNotEqualToMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    NotEqualToValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], NotEqualToValidator.prototype, "nbvNotEqualTo", void 0);
    __decorate([
        Input()
    ], NotEqualToValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], NotEqualToValidator.prototype, "nbvNotEqualToValTitle", void 0);
    __decorate([
        Input()
    ], NotEqualToValidator.prototype, "nbvNotEqualToMsgHtml", void 0);
    __decorate([
        Input()
    ], NotEqualToValidator.prototype, "validationOptions", void 0);
    NotEqualToValidator = __decorate([
        Directive({
            selector: '[nbvNotEqualTo][formControlName],[nbvNotEqualTo][formControl],[nbvNotEqualTo][ngModel]',
            providers: [NOT_EQUAL_TO_VALIDATOR]
        })
    ], NotEqualToValidator);
    return NotEqualToValidator;
}());
function getInnerHTML$i(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getNotEqualTo(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getNotEqualTo(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var NUMBER_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return NumberValidator; }),
    multi: true
};
var NumberValidator = /** @class */ (function () {
    function NumberValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    NumberValidator.prototype.validate = function (c) {
        // return number(c);
        var vClassSuffix = '-nbvNumber';
        var iValidated = number(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$j(this.nbvNumberMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    NumberValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], NumberValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], NumberValidator.prototype, "nbvNumberMsgHtml", void 0);
    NumberValidator = __decorate([
        Directive({
            selector: '[nbvNumber][formControlName],[nbvNumber][formControl],[nbvNumber][ngModel]',
            providers: [NUMBER_VALIDATOR]
        })
    ], NumberValidator);
    return NumberValidator;
}());
function getInnerHTML$j(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getNumber();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var PROPERTY_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return PropertyValidator; }),
    multi: true
};
var PropertyValidator = /** @class */ (function () {
    function PropertyValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    PropertyValidator.prototype.ngOnInit = function () {
        this.validator = property(this.nbvProperty);
    };
    PropertyValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvProperty') {
                this.validator = property(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    PropertyValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvProperty';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$k(this.nbvPropertyMsgHtml, iValidated, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    PropertyValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    PropertyValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], PropertyValidator.prototype, "nbvProperty", void 0);
    __decorate([
        Input()
    ], PropertyValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], PropertyValidator.prototype, "nbvPropertyMsgHtml", void 0);
    PropertyValidator = __decorate([
        Directive({
            selector: '[nbvProperty][formControlName],[nbvProperty][formControl],[nbvProperty][ngModel]',
            providers: [PROPERTY_VALIDATOR]
        })
    ], PropertyValidator);
    return PropertyValidator;
}());
function getInnerHTML$k(msgHtml, iValidated, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getProperty(iValidated);
        innerHTML = vMessage.title + '<br/>' + vMessage.description;
    }
    return innerHTML;
}

var RANGE_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return RangeValidator; }),
    multi: true
};
var RangeValidator = /** @class */ (function () {
    function RangeValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    RangeValidator.prototype.ngOnInit = function () {
        this.validator = range(this.nbvRange);
    };
    RangeValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvRange') {
                this.validator = range(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    RangeValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvRange';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$l(this.nbvRange, this.nbvRangeValTitle, this.nbvRangeMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    RangeValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    RangeValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], RangeValidator.prototype, "nbvRange", void 0);
    __decorate([
        Input()
    ], RangeValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], RangeValidator.prototype, "nbvRangeValTitle", void 0);
    __decorate([
        Input()
    ], RangeValidator.prototype, "nbvRangeMsgHtml", void 0);
    RangeValidator = __decorate([
        Directive({
            selector: '[nbvRange][formControlName],[nbvRange][formControl],[nbvRange][ngModel]',
            providers: [RANGE_VALIDATOR]
        })
    ], RangeValidator);
    return RangeValidator;
}());
function getInnerHTML$l(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getRange({ lowerBound: valueTitle[0], upperBound: valueTitle[1] });
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getRange({ lowerBound: value[0], upperBound: value[1] });
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var RANGE_LENGTH_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return RangeLengthValidator; }),
    multi: true
};
var RangeLengthValidator = /** @class */ (function () {
    function RangeLengthValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    RangeLengthValidator.prototype.ngOnInit = function () {
        this.validator = rangeLength(this.nbvRangeLength);
    };
    RangeLengthValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvRangeLength') {
                this.validator = rangeLength(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    RangeLengthValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvRangeLength';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$m(this.nbvRangeLength, this.nbvRangeLengthValTitle, this.nbvRangeLengthMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    RangeLengthValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    RangeLengthValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], RangeLengthValidator.prototype, "nbvRangeLength", void 0);
    __decorate([
        Input()
    ], RangeLengthValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], RangeLengthValidator.prototype, "nbvRangeLengthValTitle", void 0);
    __decorate([
        Input()
    ], RangeLengthValidator.prototype, "nbvRangeLengthMsgHtml", void 0);
    RangeLengthValidator = __decorate([
        Directive({
            selector: '[nbvRangeLength][formControlName],[nbvRangeLength][formControl],[nbvRangeLength][ngModel]',
            providers: [RANGE_LENGTH_VALIDATOR]
        })
    ], RangeLengthValidator);
    return RangeLengthValidator;
}());
function getInnerHTML$m(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getRangeLength(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getRangeLength(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var URL_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return UrlValidator; }),
    multi: true
};
var UrlValidator = /** @class */ (function () {
    function UrlValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    UrlValidator.prototype.validate = function (c) {
        // return url(c);
        var vClassSuffix = '-nbvUrl';
        var iValidated = url(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$n(this.nbvUrlMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    UrlValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], UrlValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], UrlValidator.prototype, "nbvUrlMsgHtml", void 0);
    UrlValidator = __decorate([
        Directive({
            selector: '[nbvUrl][formControlName],[nbvUrl][formControl],[nbvUrl][ngModel]',
            providers: [URL_VALIDATOR]
        })
    ], UrlValidator);
    return UrlValidator;
}());
function getInnerHTML$n(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getUrl();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var UUID_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return UUIDValidator; }),
    multi: true
};
var UUIDValidator = /** @class */ (function () {
    function UUIDValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    UUIDValidator.prototype.ngOnInit = function () {
        this.validator = uuid(this.nbvUuid);
    };
    UUIDValidator.prototype.ngOnChanges = function (changes) {
        for (var key in changes) {
            if (key === 'nbvUuid') {
                this.validator = uuid(changes[key].currentValue);
                if (this.onChange) {
                    this.onChange();
                }
            }
        }
    };
    UUIDValidator.prototype.validate = function (c) {
        // return this.validator(c);
        var vClassSuffix = '-nbvUuid';
        var iValidated = this.validator(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$o(this.nbvUuidMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    UUIDValidator.prototype.registerOnValidatorChange = function (fn) {
        this.onChange = fn;
    };
    UUIDValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], UUIDValidator.prototype, "nbvUuid", void 0);
    __decorate([
        Input()
    ], UUIDValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], UUIDValidator.prototype, "nbvUuidMsgHtml", void 0);
    UUIDValidator = __decorate([
        Directive({
            selector: '[nbvUuid][formControlName],[nbvUuid][formControl],[nbvUuid][ngModel]',
            providers: [UUID_VALIDATOR]
        })
    ], UUIDValidator);
    return UUIDValidator;
}());
function getInnerHTML$o(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getUuid();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

// import {minLength} from './validator';
var MinLength_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return MinlengthValidator; }),
    multi: true
};
var MinlengthValidator = /** @class */ (function () {
    function MinlengthValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    MinlengthValidator.prototype.validate = function (c) {
        var vClassSuffix = '-nbvMinlength';
        // Start Method 1 Worked Very Good
        var iValidated = false;
        if (isNullOrUndefined(c.value)) {
            iValidated = false;
        }
        else {
            if (c.value.toString().length === 0) {
                iValidated = false;
            }
            else if (c.value.toString().length < this.nbvMinlength) {
                iValidated = true;
            }
            else {
                iValidated = false;
            }
        }
        // End Method 1 Worked Very Good
        // // Start Method 2
        // const iValidated = minLength(c, this.nbvMinlength);
        // // End Method 2
        if (iValidated) {
            var innerHTML = getInnerHTML$p(this.nbvMinlength, this.nbvMinlengthTitle, this.nbvMinlengthMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
            return { nbvMinlength: true };
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
            return null;
        }
    };
    MinlengthValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], MinlengthValidator.prototype, "nbvMinlength", void 0);
    __decorate([
        Input()
    ], MinlengthValidator.prototype, "nbvMinlengthTitle", void 0);
    __decorate([
        Input()
    ], MinlengthValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], MinlengthValidator.prototype, "nbvMinlengthMsgHtml", void 0);
    MinlengthValidator = __decorate([
        Directive({
            selector: '[nbvMinlength][formControlName],[nbvMinlength][formControl],[nbvMinlength][ngModel]',
            providers: [MinLength_VALIDATOR]
        })
    ], MinlengthValidator);
    return MinlengthValidator;
}());
function getInnerHTML$p(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getMinLength(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getMinLength(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

function isNull(arg) {
    return arg === null;
}
var Required_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return RequiredValidator; }),
    multi: true
};
var RequiredValidator = /** @class */ (function () {
    function RequiredValidator(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
        this.iValidated = false;
        this.vClassSuffix = '-nbvRequired';
    }
    RequiredValidator.prototype.onBlur = function () {
        this.manageAlert();
    };
    RequiredValidator.prototype.validate = function (abstractControl) {
        this.abstractControl = abstractControl;
        // // Start Method 1 Worked Very Good
        // if (isNullOrUndefined(c.value)) {
        //   iValidated = true;
        // } else if (c.value.toString().length === 0) {
        //   iValidated = true;
        // } else {
        //   iValidated = false;
        // }
        // // End Method 1 Worked Very Good
        // Start Method 2 Worked Very Good
        if (isNull(Validators.required(abstractControl))) {
            this.iValidated = false;
        }
        else {
            this.iValidated = Validators.required(abstractControl)['required'];
        }
        return this.manageAlert();
        // End Method 2 Worked Very Good
    };
    RequiredValidator.prototype.manageAlert = function () {
        if (this.iValidated) {
            if (this.abstractControl.dirty || this.abstractControl.touched || this.submitted) {
                var innerHTML = getInnerHTML$q(this.nbvRequiredMsgHtml, this.nbvRequiredFieldLabel, this._ValidationMessage);
                manageAddValidationAlert(this.dest, this.vClassSuffix, innerHTML, this._ValidationConfig);
            }
            else {
                manageDelValidationAlert(this.dest, this.vClassSuffix);
            }
            return { 'nbvRequired': true };
        }
        else {
            manageDelValidationAlert(this.dest, this.vClassSuffix);
            return null;
        }
    };
    RequiredValidator.prototype.ngOnChanges = function (changes) {
        if (changes.hasOwnProperty('submitted')) {
            this.mySubmitted = this.submitted;
            if (this.abstractControl) {
                if (this.mySubmitted) {
                    this.abstractControl.markAsTouched();
                }
                else {
                    this.abstractControl.markAsUntouched();
                }
            }
            this.manageAlert();
        }
    };
    RequiredValidator.prototype.registerOnValidatorChange = function (fn) {
    };
    RequiredValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], RequiredValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], RequiredValidator.prototype, "nbvRequiredMsgHtml", void 0);
    __decorate([
        Input()
    ], RequiredValidator.prototype, "nbvRequiredFieldLabel", void 0);
    __decorate([
        Input()
    ], RequiredValidator.prototype, "submitted", void 0);
    __decorate([
        HostListener('blur')
    ], RequiredValidator.prototype, "onBlur", null);
    RequiredValidator = __decorate([
        Directive({
            selector: '[nbvRequired][formControlName],[nbvRequired][formControl],[nbvRequired][ngModel]',
            providers: [Required_VALIDATOR]
        })
    ], RequiredValidator);
    return RequiredValidator;
}());
function getInnerHTML$q(msgHtml, nbvRequiredFieldLabel, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getRequired(nbvRequiredFieldLabel);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var MaxLength_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return MaxlengthValidator; }),
    multi: true
};
var MaxlengthValidator = /** @class */ (function () {
    function MaxlengthValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    MaxlengthValidator.prototype.validate = function (c) {
        var vClassSuffix = '-nbvMaxlength';
        var iValidated = false;
        // alert('c.value.toString().length = ' + c.value.toString().length);
        // alert('this.nbvMinlength = ' + this.nbvMinlength);
        if (isNullOrUndefined(c.value)) {
            iValidated = false;
        }
        else {
            if (c.value.toString().length > this.nbvMaxlength) {
                iValidated = true;
            }
            else {
                iValidated = false;
            }
        }
        if (iValidated) {
            var innerHTML = getInnerHTML$r(this.nbvMaxlength, this.nbvMaxlengthTitle, this.nbvMaxlengthMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
            return { nbvMaxlength: true };
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
            return null;
        }
    };
    MaxlengthValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], MaxlengthValidator.prototype, "nbvMaxlength", void 0);
    __decorate([
        Input()
    ], MaxlengthValidator.prototype, "nbvMaxlengthTitle", void 0);
    __decorate([
        Input()
    ], MaxlengthValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], MaxlengthValidator.prototype, "nbvMaxlengthMsgHtml", void 0);
    MaxlengthValidator = __decorate([
        Directive({
            selector: '[nbvMaxlength][formControlName],[nbvMaxlength][formControl],[nbvMaxlength][ngModel]',
            providers: [MaxLength_VALIDATOR]
        })
    ], MaxlengthValidator);
    return MaxlengthValidator;
}());
function getInnerHTML$r(value, valueTitle, msgHtml, _ValidationMessage) {
    var innerHTML;
    // alert('msgHtml: ')
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else if (!isNullOrUndefined(valueTitle)) {
        var vMessage = _ValidationMessage.getMaxLength(valueTitle);
        innerHTML = vMessage.title;
    }
    else {
        var vMessage = _ValidationMessage.getMaxLength(value);
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var Pattern_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return PatternValidator; }),
    multi: true
};
var PatternValidator = /** @class */ (function () {
    function PatternValidator(ValidationConfig, _ValidationMessage) {
        this.ValidationConfig = ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    PatternValidator.prototype.validate = function (c) {
        var vClassSuffix = '-nbvPattern';
        // const iValidated = pattern(c, this.nbvPattern);
        var iValidated = false;
        if (isNullOrUndefined(c.value)) {
            iValidated = false;
        }
        else {
            if (c.value.toString().length === 0) {
                iValidated = false;
            }
            else if (new RegExp('^' + this.nbvPattern + '$').test(c.value)) {
                iValidated = false;
            }
            else {
                iValidated = true;
            }
        }
        if (iValidated) {
            var innerHTML = getInnerHTML$s(this.nbvPatternMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this.ValidationConfig);
            return { 'nbvPattern': true };
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
            return null;
        }
    };
    PatternValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], PatternValidator.prototype, "nbvPattern", void 0);
    __decorate([
        Input()
    ], PatternValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], PatternValidator.prototype, "nbvPatternMsgHtml", void 0);
    PatternValidator = __decorate([
        Directive({
            selector: '[nbvPattern][formControlName],[nbvPattern][formControl],[nbvPattern][ngModel]',
            providers: [Pattern_VALIDATOR]
        })
    ], PatternValidator);
    return PatternValidator;
}());
function getInnerHTML$s(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getDefault();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}

var NATIONALCODE_VALIDATOR = {
    provide: NG_VALIDATORS,
    useExisting: forwardRef(function () { return NationalCodeValidator; }),
    multi: true
};
var NationalCodeValidator = /** @class */ (function () {
    function NationalCodeValidator(_ValidationConfig, _ValidationMessage) {
        this._ValidationConfig = _ValidationConfig;
        this._ValidationMessage = _ValidationMessage;
    }
    NationalCodeValidator.prototype.validate = function (c) {
        var vClassSuffix = '-nbvNationalCode';
        var iValidated = nationalCode(c);
        if (iValidated) {
            var innerHTML = getInnerHTML$t(this.nbvNationalCodeMsgHtml, this._ValidationMessage);
            manageAddValidationAlert(this.dest, vClassSuffix, innerHTML, this._ValidationConfig);
        }
        else {
            manageDelValidationAlert(this.dest, vClassSuffix);
        }
        return iValidated;
    };
    NationalCodeValidator.ctorParameters = function () { return [
        { type: ValidationConfig },
        { type: ValidationMessage }
    ]; };
    __decorate([
        Input()
    ], NationalCodeValidator.prototype, "dest", void 0);
    __decorate([
        Input()
    ], NationalCodeValidator.prototype, "nbvNationalCodeMsgHtml", void 0);
    NationalCodeValidator = __decorate([
        Directive({
            selector: '[nbvNationalCode][formControlName],[nbvNationalCode][formControl],[nbvNationalCode][ngModel]',
            providers: [NATIONALCODE_VALIDATOR]
        })
    ], NationalCodeValidator);
    return NationalCodeValidator;
}());
function getInnerHTML$t(msgHtml, _ValidationMessage) {
    var innerHTML;
    if (!isNullOrUndefined(msgHtml)) {
        innerHTML = msgHtml;
    }
    else {
        var vMessage = _ValidationMessage.getNationalCode();
        innerHTML = vMessage.title;
    }
    return innerHTML;
}
// export  function Fa2En(value: any): any {
//   const englishNumbers = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'];
//   const persianNumbers = ['۱', '۲', '۳', '۴', '۵', '۶', '۷', '۸', '۹', '۰'];
//   if(isNullOrUndefined(value))
//     return value;
//   let myvalue: string = value.toString();
//   if(!isNullOrUndefined(value)) {
//     for (let i = 0, numbersLen = persianNumbers.length; i < numbersLen; i++) {
//       myvalue = myvalue.replace(new RegExp(persianNumbers[i], 'g'), englishNumbers[i]);
//     }
//   }
//   return myvalue;
// }

var NbValidators = {
    arrayLength: arrayLength,
    base64: base64,
    creditCard: creditCard,
    date: date,
    dateISO_8601: dateISO_8601,
    digits: digits,
    email: email,
    equal: equal,
    equalTo: equalTo,
    gt: gt,
    gte: gte,
    json: json,
    lt: lt,
    lte: lte,
    max: max,
    maxDate: maxDate,
    min: min,
    minDate: minDate,
    notEqual: notEqual,
    notEqualTo: notEqualTo,
    number: number,
    property: property,
    range: range,
    rangeLength: rangeLength,
    url: url,
    uuid: uuid,
    nationalCode: nationalCode
};
var CustomDirectives = [
    ArrayLengthValidator,
    Base64Validator,
    CreditCardValidator,
    DateValidator,
    DateISOValidator,
    DigitsValidator,
    EmailValidator,
    EqualValidator,
    EqualToValidator,
    GreaterThanValidator,
    GreaterThanEqualValidator,
    JSONValidator,
    LessThanValidator,
    LessThanEqualValidator,
    MaxValidator,
    MaxDateValidator,
    MinValidator,
    MinDateValidator,
    NotEqualValidator,
    NotEqualToValidator,
    NumberValidator,
    PropertyValidator,
    RangeValidator,
    RangeLengthValidator,
    UrlValidator,
    UUIDValidator,
    MinlengthValidator,
    MaxlengthValidator,
    RequiredValidator,
    PatternValidator,
    NationalCodeValidator
];
var NbValidationModule = /** @class */ (function () {
    function NbValidationModule() {
    }
    NbValidationModule = __decorate([
        NgModule({
            declarations: [CustomDirectives],
            exports: [CustomDirectives]
        })
    ], NbValidationModule);
    return NbValidationModule;
}());

var CustomPattern = /** @class */ (function () {
    function CustomPattern() {
    }
    CustomPattern.onlyEnglishLettersWithSpecificLength = /** @class */ (function () {
        function class_1() {
        }
        class_1.getPattern = function (length) {
            return '[a-z]{' + length + '}';
        };
        class_1.getPatternMsgHtml = function (length) {
            return 'مقدار وارد شده باید حروف انگلیسی و ' + length + ' حرف باشد';
        };
        return class_1;
    }());
    return CustomPattern;
}());

var ValidationMessageHelper = /** @class */ (function () {
    function ValidationMessageHelper(title, description) {
        this.title = title;
        this.description = description;
    }
    return ValidationMessageHelper;
}());

var ValidationMessageImpl = /** @class */ (function () {
    function ValidationMessageImpl() {
    }
    ValidationMessageImpl.prototype.getGt = function (value) {
        return new ValidationMessageHelper('عدد وارد شده باید بزرگ‌تر از ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getGte = function (value) {
        return new ValidationMessageHelper('عدد وارد شده باید بزرگ‌تر یا مساوی ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getEqualTo = function (value) {
        return new ValidationMessageHelper('مقدار وارد شده باید برابر با ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getNotEqualTo = function (value) {
        return new ValidationMessageHelper('مقدار وارد شده نباید برابر با ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getEqual = function (value) {
        return new ValidationMessageHelper('مقدار وارد شده باید برابر با ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getNotEqual = function (value) {
        return new ValidationMessageHelper('مقدار وارد شده نباید برابر با ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getEmail = function () {
        return new ValidationMessageHelper('ایمیل وارد شده صحیح نیست', null);
    };
    ValidationMessageImpl.prototype.getUrl = function () {
        return new ValidationMessageHelper('url وارد شده صحیح نیست', null);
    };
    ValidationMessageImpl.prototype.getUuid = function () {
        return new ValidationMessageHelper('uuid وارد شده صحیح نیست', null);
    };
    ValidationMessageImpl.prototype.getDigits = function () {
        return new ValidationMessageHelper('فقط ارقام ریاضی مجاز هستند', null);
    };
    ValidationMessageImpl.prototype.getNumber = function () {
        return new ValidationMessageHelper('مقدار وارد شده باید عدد باشد', null);
    };
    ValidationMessageImpl.prototype.getDateISO_8601 = function () {
        return new ValidationMessageHelper('فرمت وارد شده صحبح نیست', "<i class=\"fa fa-info-circle\" aria-hidden=\"true\"></i> \u0645\u062B\u0627\u0644 2018/02/15\n      ");
    };
    ValidationMessageImpl.prototype.getDate = function () {
        return new ValidationMessageHelper('فرمت وارد شده صحبح نیست', "\n<i class=\"fa fa-info-circle\" aria-hidden=\"true\"></i> \u0645\u062B\u0627\u0644\n");
    };
    ValidationMessageImpl.prototype.getCreditCard = function () {
        return new ValidationMessageHelper('کارت اعتباری معتبر نیست', null);
    };
    ValidationMessageImpl.prototype.getBase64 = function () {
        return new ValidationMessageHelper('رشته ورودی base64 نیست', null);
    };
    ValidationMessageImpl.prototype.getJson = function () {
        return new ValidationMessageHelper('رشته ورودی json نیست', null);
    };
    ValidationMessageImpl.prototype.getLt = function (value) {
        return new ValidationMessageHelper('عدد وارد شده باید کوچک‌تر از ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getLte = function (value) {
        return new ValidationMessageHelper('عدد وارد شده باید کوچک‌تر یا مساوی ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getMax = function (value) {
        return new ValidationMessageHelper('مقدار وارد شده نباید بزرگ‌تر از ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getMaxDate = function (value) {
        return new ValidationMessageHelper('تاریخ وارد شده نباید بزرگ‌تر از ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getMin = function (value) {
        return new ValidationMessageHelper('مقدار وارد شده نباید کوچک‌تر از ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getMinDate = function (value) {
        return new ValidationMessageHelper('تاریخ وارد شده نباید کوچک‌تر از ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getProperty = function (iValidated) {
        var e_1, _a;
        var list;
        list = "<ul>";
        try {
            for (var _b = __values(iValidated.errorProperty), _c = _b.next(); !_c.done; _c = _b.next()) {
                var prop = _c.value;
                list = list + "<li>" + prop + "</li>";
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        list = list + "</ul>";
        return new ValidationMessageHelper('برخی propertyها مقدار ندارند', "\n      \u0644\u06CC\u0633\u062A property\u0647\u0627\u06CC\u06CC \u06A9\u0647 \u0645\u0642\u062F\u0627\u0631 \u0646\u062F\u0627\u0631\u0646\u062F:\n      " + list);
    };
    ValidationMessageImpl.prototype.isDigit = function (value) {
        return /^([0-9]*)$|^([۰-۹]*)$/.test(value);
    };
    ValidationMessageImpl.prototype.getRange = function (value) {
        var v0 = this.isDigit(value.lowerBound) === true ? value.lowerBound - 1 : value.lowerBound;
        var v1 = this.isDigit(value.upperBound) === true ? value.upperBound + 1 : value.upperBound;
        return new ValidationMessageHelper('مقدار وارد شده باید بین ' + v0 + ' و ' + v1 + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getRangeLength = function (value) {
        // alert('isDigit(' + value[0] + ') = ' + this.isDigit(value[0]));
        var v0 = this.isDigit(value[0]) === true ? value[0] - 1 : value[0];
        var v1 = this.isDigit(value[1]) === true ? value[1] + 1 : value[1];
        return new ValidationMessageHelper('طول مقدار وارد شده باید بین ' + v0 + ' و ' + v1 + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getMinLength = function (value) {
        return new ValidationMessageHelper('طول مقدار وارد شده باید بزرگتر مساوی ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getMaxLength = function (value) {
        return new ValidationMessageHelper('طول مقدار وارد شده باید کوچکتر مساوی ' + value + ' باشد', null);
    };
    ValidationMessageImpl.prototype.getRequired = function (nbvRequiredFieldLabel) {
        if (isNullOrUndefined(nbvRequiredFieldLabel)) {
            return new ValidationMessageHelper('پر کردن این فیلد الزامی است', null);
        }
        else {
            return new ValidationMessageHelper('پر کردن فیلد ' + nbvRequiredFieldLabel + ' الزامی است', null);
        }
    };
    ValidationMessageImpl.prototype.getDefault = function () {
        return new ValidationMessageHelper('مقدار وارد شده قابل قبول نیست', null);
    };
    return ValidationMessageImpl;
}());

var ValidationOptions = /** @class */ (function () {
    function ValidationOptions() {
    }
    return ValidationOptions;
}());

/*
 * Public API Surface of validation
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CustomPattern, NbValidationModule, NbValidators, ValidationComponent, ValidationConfig, ValidationMessage, ValidationMessageHelper, ValidationMessageImpl, ValidationModule, ValidationOptions, ValidationService, ValidationSrcType, addValidationEl, delValidationEl, deleteElementByClassName, getMyValidationElement, isDate, isPresent, manageAddValidationAlert, manageDelValidationAlert, parseDate, arrayLength as ɵa, base64 as ɵb, nationalCode as ɵba, ArrayLengthValidator as ɵbb, Base64Validator as ɵbc, CreditCardValidator as ɵbd, DateValidator as ɵbe, DateISOValidator as ɵbf, DigitsValidator as ɵbg, EmailValidator as ɵbh, EqualValidator as ɵbi, EqualToValidator as ɵbj, GreaterThanValidator as ɵbk, GreaterThanEqualValidator as ɵbl, JSONValidator as ɵbm, LessThanValidator as ɵbn, LessThanEqualValidator as ɵbo, MaxValidator as ɵbp, MaxDateValidator as ɵbq, MinValidator as ɵbr, MinDateValidator as ɵbs, NotEqualValidator as ɵbt, NotEqualToValidator as ɵbu, NumberValidator as ɵbv, PropertyValidator as ɵbw, RangeValidator as ɵbx, RangeLengthValidator as ɵby, UrlValidator as ɵbz, creditCard as ɵc, UUIDValidator as ɵca, MinlengthValidator as ɵcb, MaxlengthValidator as ɵcc, RequiredValidator as ɵcd, PatternValidator as ɵce, NationalCodeValidator as ɵcf, date as ɵd, dateISO_8601 as ɵe, digits as ɵf, email as ɵg, equal as ɵh, equalTo as ɵi, gt as ɵj, gte as ɵk, json as ɵl, lt as ɵm, lte as ɵn, max as ɵo, maxDate as ɵp, min as ɵq, minDate as ɵr, notEqual as ɵs, notEqualTo as ɵt, number as ɵu, property as ɵv, range as ɵw, rangeLength as ɵx, url as ɵy, uuid as ɵz };
//# sourceMappingURL=angular-boot-validation.js.map
